unit S250main;

interface

uses Windows, Classes, Graphics, Forms, Controls, Menus,
  Dialogs, StdCtrls, Buttons, ExtCtrls, sysUtils, Messages, clipBrd,
  ComCtrls, XPMan, ImgList,
  ADport, adexcept, oomisc, awuser, math,
  s250cst, jmmUtil, S250cfg;

// const
//    WM_S250_Code = WM_USER + 0;

type
  Tmode = (mNone,mSpectreAuto,mSpectreMinMax,mCinetique,mBeer);

  TFormMain = class(TForm)
    VoieSerie: TApdComPort;
    BoutonPanel: TPanel;
    ExitBtn: TBitBtn;
    AboutBtn: TBitBtn;
    Timer: TTimer;
    Notebook: TPageControl;
    StartBtn: TBitBtn;
    CinetiqueBtn: TBitBtn;
    SpectreAutoBtn: TBitBtn;
    SpectreMinMaxBtn: TBitBtn;
    ComBtn: TBitBtn;
    DirectBtn: TBitBtn;
    BeerBtn: TBitBtn;
    ListeSpectro: TComboBox;
    Label6: TLabel;
    LabelWait: TLabel;
    Memo1: TMemo;
    Memo2: TMemo;
    HelpBtn: TBitBtn;
    Comports: TRadioGroup;
    AttenteTS : TtabSheet;
    MenuTS : TtabSheet;
    ImageList1: TImageList;
    procedure ExitItemClick(Sender: TObject);
    procedure AboutItemClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ComBtnClick(Sender: TObject);
    procedure SpectreAutoBtnClick(Sender: TObject);
    procedure CinetiqueBtnClick(Sender: TObject);
    procedure SpectreMinMaxBtnClick(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure VoieSerieTriggerData(CP: TObject; TriggerHandle: Word);
    procedure VoieSerieTriggerAvail(CP: TObject; Count: Word);
    procedure StartBtnClick(Sender: TObject);
    procedure DirectBtnClick(Sender: TObject);
    procedure BeerBtnClick(Sender: TObject);
    procedure ListeSpectroChange(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure HelpBtnClick(Sender: TObject);
    procedure ComportsClick(Sender: TObject);
    procedure SpectreMainBeerActionExecute(Sender: TObject);
  private
    SpectroPret,AvecVerif : boolean;
    NomAppareil : string;
    hOui,hNon : word;
    ChaineLue : ansiString;
    NumeroCom : array[0..MaxComHandles] of integer;
    Procedure AppActivate(sender : Tobject);
    Procedure ShowHint(Sender: TObject);
    Procedure GetString(const commande : shortString;Nbre : byte;TimeOut : integer);
  public
    zeroAbs : double;
    AppelRegressi : boolean;
    AcquisitionEnCours : Tmode;
    procedure initialisation;
    Procedure SetMode(Acq : Tmode);
    Procedure SetLambda(lambda : word);
    function GetAbsorbance : double;
    procedure setZero;
  protected
//    procedure WMS250Code(var Message: Tmessage); message WM_S250_Code;
  end;

var
  FormMain: TFormMain;

implementation

uses S250about, S250com, S250Auto, S250cinet, S250Manu, S250Beer;

{$R *.DFM}

Procedure TformMain.AppActivate(sender : Tobject);
begin
    Case AcquisitionEnCours of
       mSpectreAuto : SpectreForm.setFocus;
       mSpectreMinMax : SpectreManuel.setFocus;
       mCinetique : CinetiqueForm.setFocus;
       mBeer : BeerForm.setFocus;
    end;
end;

procedure TFormMain.ExitItemClick(Sender: TObject);
begin
   Close
end;

procedure TFormMain.AboutItemClick(Sender: TObject);
begin
    AboutBox.ShowModal
end;

procedure TFormMain.FormCreate(Sender: TObject);
var k : integer;
begin
  Application.OnActivate := AppActivate;
  Application.OnHint := ShowHint;
  Application.ShowHint := true;
  zeroAbs := 0;
  AppelRegressi := false;
  AcquisitionEnCours := mNone;
  SpectroPret := false;
  hOui := 0;hNon := 0;
  S250 := Tspectro.create;
  S250.chargeConfig;
  voieSerie.comNumber := S250.comNumber;
  Timer.interval := timeOutMs;
  voieSerie.Baud := S250.baud;
  NoteBook.activePage := AttenteTS;
  ListeSpectro.clear;
  for k := 0 to pred(S250.NbreSpectro) do
      ListeSpectro.Items.Add(Spectros[k].nom);
  listeSpectro.ItemIndex := S250.numeroSpectro;
  ComPorts.items.clear;
  for k := 1 to MaxComHandles do
      if IsPortAvailable(k) then begin
          NumeroCom[comports.Items.Count] := k;
          ComPorts.Items.Add('COM'+IntToStr(k));
          if S250.ComNumber=k then Comports.ItemIndex := pred(Comports.items.count);
      end;
  if Comports.itemIndex=-1 then begin
     Comports.itemIndex := 0;
     voieSerie.comNumber := NumeroCom[0];
     S250.ComNumber := voieSerie.comNumber;
  end;
  if Comports.Items.Count<4 then Comports.columns := Comports.Items.Count;
  listeSpectroChange(nil);
end;

procedure TFormMain.FormClose(Sender: TObject;var Action: TCloseAction);
var nom : string;
begin
     if VoieSerie.Tracing=tlOn then VoieSerie.Tracing := tlDump;
     if VoieSerie.Logging=tlOn then VoieSerie.Logging := tlDump;
     if spectroPret and avecVerif then S250.SauveConfig;
     VoieSerie.Open := false;
     S250.Free;
{$IFDEF DEBUG}
// recopier trace  diffrents endroits
     CopyFile(PWideChar(voieSerie.traceName),PWideChar(mesDocsDir+'s250.trc'),false);
     CopyFile(PWideChar(voieSerie.logName),PWideChar(mesDocsDir+'s250.log'),false);
     nom := application.exeName;
     CopyFile(PWideChar(voieSerie.traceName),PWideChar(changeFileExt(nom,'.trc')),false);
     CopyFile(PWideChar(voieSerie.logName),PWideChar(changeFileExt(nom,'.log')),false);
{$ENDIF}
end;

procedure TFormMain.SetMode(Acq : Tmode);
begin
     constanteDlg.newPageCB.itemIndex := 0;
     SpectreAutoBtn.visible := Acq in [mNone,mSpectreAuto];
     CinetiqueBtn.visible := Acq in [mNone,mCinetique];
     BeerBtn.visible := Acq in [mNone,mBeer];
     SpectreMinMaxBtn.visible := Acq in [mNone,mSpectreMinMax];
     if spectroPret
        then NoteBook.activePage := MenuTS
        else NoteBook.activePage := AttenteTS;
     AcquisitionEnCours := Acq;
     if spectroPret
        then NomAppareil := NomAppareil+' prt'
        else NomAppareil := Spectros[S250.NumeroSpectro].nom+' non trouv';
     if Acq=mNone then begin
        voieSerie.OnTriggerAvail := VoieSerieTriggerAvail;
        voieSerie.OnTriggerData := VoieSerieTriggerData;
     end;
end;

procedure TFormMain.ComBtnClick(Sender: TObject);
var k : integer;
begin
     timer.enabled := false;
     Application.processMessages;
     if ComCfgDlg.ShowModal=mrOK then begin
        voieSerie.Open := false;
        if hOui<>0 then VoieSerie.removeTrigger(hOui);
        hOui := 0;
        if hNon<>0 then VoieSerie.removeTrigger(hNon);
        hNon := 0;
        Timer.interval := TimeOutMs;
        ListeSpectro.clear;
        for k := 0 to pred(S250.NbreSpectro) do
            ListeSpectro.Items.Add(Spectros[k].nom);
        listeSpectro.ItemIndex := S250.numeroSpectro;
        ListeSpectroChange(sender);
        SpectroPret := false;
        StartBtn.visible := true;
        LabelWait.caption :='';
     end;
     setMode(mNone);
end;

procedure TFormMain.ShowHint(Sender: TObject);
begin
   if Application.Hint<>''
      then case AcquisitionEnCours of
          mSpectreAuto : SpectreForm.caption := Application.Hint;
          mSpectreMinMax : SpectreManuel.caption := Application.Hint;
          mCinetique : CinetiqueForm.Caption := Application.Hint;
          mBeer : BeerForm.Caption := Application.Hint;
          mNone : Caption := Application.Hint;
      end
      else case AcquisitionEnCours of
          mSpectreAuto : SpectreForm.caption := NomAppareil;
          mSpectreMinMax : SpectreManuel.caption := NomAppareil;
          mCinetique : CinetiqueForm.Caption := NomAppareil;
          mBeer : BeerForm.Caption := NomAppareil;
          mNone : Caption := NomAppareil;
      end
end;

procedure TFormMain.SpectreAutoBtnClick(Sender: TObject);
begin
    setMode(mSpectreAuto);
    SpectreForm.show;
end;

procedure TFormMain.CinetiqueBtnClick(Sender: TObject);
begin
    setMode(mCinetique);
    CinetiqueForm.show;
end;

procedure TFormMain.SetLambda(lambda : word);
begin
    ChaineLue := '';
    voieSerie.output := crESC+ansiChar('1')+
         ansichar(Hi(Lambda))+ansichar(Lo(Lambda))+
         ansichar(Hi(lambdaLampe))+ansichar(Lo(lambdaLampe))+
         ansichar(255)
end;

Procedure TFormMain.GetString(const Commande : shortstring;
    Nbre : byte;TimeOut : integer);
var ET : eventTimer;
begin
    ChaineLue := '';
    voieSerie.FlushInBuffer;
    voieSerie.outPut := commande;
    NewTimer(ET,TimeOut);
    repeat Application.processMessages
    until TimerExpired(ET) or (length(chaineLue)=Nbre);
end;

function TFormMain.GetAbsorbance : double;
begin
    Screen.cursor := crHourGlass;
// T au bout de 1,2 s Prim Light ; 0,5 s Advanced ; 0,8 s S250
    ChaineLue := '';
    voieSerie.FlushInBuffer;
    voieSerie.outPut := crESC+ansiChar('2');
    if voieSerie.waitForString('T',timeOut,false,false)
       then begin
         GetString('E',3,9);
// valeur au bout de 0,05 s Prim Advanced Light S250 
         if length(chaineLue)=3
            then begin
               result := (ord(chaineLue[3])*1.0+ord(chaineLue[2])*256.0)/10000.0;
               if result>6
                  then result := 0
                  else if S250.retirerZero
                       then result := result-zeroAbs;
            end
            else result := nan
      end
      else result := nan;
    Screen.cursor := crDefault;
end;

Procedure TFormMain.SetZero;
const TimeOut = 90; { 5 s }
begin
    Screen.cursor := crHourGlass;
    zeroAbs := 0;
// Lecture de T au bout de 1,3 s Prim Light ; 1,4 s Advanced ; 3,2 s S250
    ChaineLue := '';
    voieSerie.FlushInBuffer;
    voieSerie.outPut := crESC+ansiChar('0');
    if voieSerie.waitForString('T',timeOut,false,false) then begin
       GetString('E',3,9);
// Valeur au bout de 0,05 s Prim Advanced Light S250
       if length(chaineLue)=3 then begin
          zeroAbs := (ord(chaineLue[3])*1.0+ord(chaineLue[2])*256.0)/10000.0;
          if zeroAbs>6 then zeroAbs := 0; // $FF saturation ? 6.5535
       end;
    end;
    Screen.cursor := crDefault;
end;

procedure TFormMain.SpectreMinMaxBtnClick(Sender: TObject);
begin
    setMode(mSpectreMinMax);
    SpectreManuel.show;
end;

procedure TFormMain.TimerTimer(Sender: TObject);
begin
     if not spectroPret and voieSerie.Open then begin
         spectroPret := length(chaineLue)=2;
// Prim renvoie la valeur de l'absorbance sur deux octets en rponse  'Z'
         chaineLue := '';
         comports.Enabled := not spectroPret;
         AvecVerif := spectroPret;
         timer.enabled := not spectroPret;
         if spectroPret
            then initialisation // PostMessage(Handle,WM_S250_Code,1,0)
            else voieSerie.output := crESC+ansiChar('Z')
     end;
end;

procedure TFormMain.VoieSerieTriggerData(CP: TObject; TriggerHandle: Word);
begin
     if triggerHandle=hOui
        then begin
           timer.enabled := false;
           spectroPret := true;
           comports.Enabled := false;
           AvecVerif := true;           
           VoieSerie.RemoveTrigger(hOui);
           hOui := 0;
           if hNon<>0 then VoieSerie.RemoveTrigger(hNon);
           hNon := 0;
           chaineLue := '';
           timer.Enabled := false;
           // PostMessage(Handle,WM_S250_Code,1,0);
           initialisation;
        end
        else if triggerHandle=hNon then begin
           if not spectroPret then
              LabelWait.caption := 'Rponse "N" : spectro non initialis';
// spectroPret si le Prim Advanced ou Light a dj envoy Oui avant d'envoyer Non !
           VoieSerie.RemoveTrigger(hNon);
           comports.Enabled := not spectroPret;
           AvecVerif := spectroPret;
           hNon := 0;
           chaineLue := '';
           if hOui<>0 then VoieSerie.RemoveTrigger(hOui);
           hOui := 0;
           timer.Enabled := not spectroPret and (pos('Prim',listeSpectro.Text)>0);
        end;
end;

procedure TFormMain.VoieSerieTriggerAvail(CP: TObject; Count: Word);
var i : integer;
begin
   for i := 1 to count do
       if VoieSerie.CharReady
          then chaineLue := chaineLue+VoieSerie.GetChar
          else { ne devrait pas arriver mais arrive ?? }
end;

procedure TFormMain.StartBtnClick(Sender: TObject);
begin
   if not voieSerie.open then begin
        try
        NomAppareil := Spectros[S250.NumeroSpectro].Nom;
        voieSerie.logName := appDataDir+'S250.log';
        voieSerie.traceName := appDataDir+'S250.trc';
        if pos('Prim',nomAppareil)>0 then begin
           voieSerie.logName := appDataDir+'PrimC.log';
           voieSerie.traceName := appDataDir+'PrimC.trc';
        end;
        if pos('Advanced',nomAppareil)>0 then begin
           voieSerie.logName := appDataDir+'PrimAdvanced.log';
           voieSerie.traceName := appDataDir+'PrimAdvanced.trc';
        end;
        if pos('Light',nomAppareil)>0 then begin
           voieSerie.logName := appDataDir+'PrimLight.log';
           voieSerie.traceName := appDataDir+'PrimLight.trc';
        end;
        if pos('UviLine',nomAppareil)>0 then begin
           voieSerie.logName := appDataDir+'UviLine.log';
           voieSerie.traceName := appDataDir+'UviLine.trc';
        end;
        LabelWait.caption := 'Recherche Secomam '+Spectros[S250.NumeroSpectro].Nom;
        Timer.Interval := timeOutMs;
        chaineLue := '';
        voieSerie.Open := true;
 {$IFDEF DEBUG}
        voieSerie.Tracing := tlOn;
        voieSerie.Logging := tlOn;
{$ENDIF}
        if hOui=0 then hOui := VoieSerie.AddDataTrigger('O',true);
        if hNon=0 then hNon := VoieSerie.AddDataTrigger('N',true);
        StartBtn.visible := false;
        Timer.enabled := (pos('Prim',listeSpectro.Text)>0);
        // Recherche de Prim par crEsc+'Z'
        except
             AfficheErreur('Problme voie srie COM'+intToStr(voieSerie.comNumber));
        end;
     end;
end;

(*
procedure TformMain.WMS250Code(var Message: Tmessage);
var reponse : string;
begin
    if hNon<>0 then VoieSerie.removeTrigger(hNon);
    hNon := 0;
    Reponse := ' Version ';
    GetString(crEsc+ansiChar('"'),2,18);
    if (length(chaineLue)=2) and (chaineLue[1]='C')
        then Reponse := Reponse+IntToStr(ord(chaineLue[2]))
        else Reponse := Reponse+'?';
    GetString(crEsc+ansiChar('Q'),2,18);
// retourne type de S.250 250I+/E+ : 0  ; S.250T+ : 1
    if (length(chaineLue)=2) and (chaineLue[1]='T')
        then case ord(chaineLue[2])of
             0 : Reponse := Reponse+' I+';
             1 : Reponse := Reponse+' T+';
             else Reponse := Reponse + ' Type ?';
        end
        else Reponse := Reponse+' Type ?';
    chaineLue := '';
    NomAppareil := Spectros[S250.NumeroSpectro].nom+Reponse;
    setMode(mNone);
end;
 *)

procedure TformMain.initialisation;
begin
    if hNon<>0 then VoieSerie.removeTrigger(hNon);
    hNon := 0;
    if hOui<>0 then VoieSerie.removeTrigger(hOui);
    hOui := 0;
    chaineLue := '';
    NomAppareil := Spectros[S250.NumeroSpectro].nom;
    setMode(mNone);
end;

procedure TFormMain.DirectBtnClick(Sender: TObject);
begin
     if not voieSerie.open then begin
         try
         voieSerie.Open := true;
         except
            AfficheErreur('Problme voie srie sur COM'+intToStr(voieSerie.comNumber));
         end;
     end;
     if voieSerie.open then begin
        timer.enabled := false;
        spectroPret := true;
        AvecVerif := false;
        comports.Enabled := false;
        initialisation;
        // PostMessage(Handle,WM_S250_Code,2,0);
     end;
end;

procedure TFormMain.BeerBtnClick(Sender: TObject);
begin
    setMode(mBeer);
    BeerForm.show;
end;

procedure TFormMain.ListeSpectroChange(Sender: TObject);
begin
     S250.NumeroSpectro := ListeSpectro.ItemIndex;
     with Spectros[S250.NumeroSpectro] do begin
       voieSerie.baud := baudC;
       Memo1.Clear;
       memo1.lines.add(aide[1]);
       memo1.lines.add(aide[2]);
       memo1.lines.add(aide[6]);
       memo1.lines.add(aide[7]);
       Memo2.Clear;
       memo2.lines.add(aide[3]);
       memo2.lines.add(aide[4]);
       memo2.lines.add(aide[5]);
       memo2.lines.add(aide[8]);
       S250.baud := baudC;
       S250.retirerZero := retirerZeroC;
       S250.MiniLambda := miniLambdaC;
       S250.MaxiLambda := maxiLambdaC;
    end;
end;

procedure TFormMain.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if (key=vk_F8) and (ssShift in shift) then comBtnClick(sender)
end;

procedure TFormMain.HelpBtnClick(Sender: TObject);
begin
   Application.HelpCommand(HELP_Finder, 0); // dans s250.cnt
end;

procedure TFormMain.ComportsClick(Sender: TObject);
begin
     VoieSerie.ComNumber := NumeroCom[Comports.ItemIndex];
     S250.ComNumber := VoieSerie.ComNumber;
end;

procedure TFormMain.SpectreMainBeerActionExecute(Sender: TObject);
begin
    setMode(mBeer);
    BeerForm.show;
end;

end.


