unit S250uviline;

interface

uses Windows, Classes, Graphics, Forms, Controls, Menus,
   Dialogs, StdCtrls, Buttons, ExtCtrls, SysUtils, Messages,
   clipBrd, spin, inifiles, Grids, ComCtrls, ToolWin,
   ADport, adexcept, oomisc, math,
   S250cfg, graphker, jmmUtil, s250main;

type
   TSpectreUviLine = class(TForm)
      SaveDialog:    TSaveDialog;
      PaintBox:      TPaintBox;
      PanelBoutons:  TPanel;
      LambdaGB:      TGroupBox;
      DebutSE:       TSpinEdit;
      FinSE:         TSpinEdit;
      Maxi:          TLabel;
      Mini:          TLabel;
      PanelDuree:    TPanel;
      Header:        THeaderControl;
      SpectreGB:     TGroupBox;
      SpectreGrid:   TStringGrid;
      Edit1:         TEdit;
      PanelLambda:   TPanel;
      Edit2:         TEdit;
      ToolBar1:      TToolBar;
      SaveBtn:       TToolButton;
      BlancBtn:      TToolButton;
      ReticuleBtn:   TToolButton;
      ExitBtn:       TToolButton;
      ResetBtn:      TToolButton;
      UndoBtn:       TToolButton;
      SpectreBtn:    TToolButton;
      PrintBtn:      TToolButton;
      SavePopupMenu: TPopupMenu;
      RegressiM:     TMenuItem;
      ClipM:         TMenuItem;
      FileM:         TMenuItem;
      procedure ExitItemClick(Sender: TObject);
      procedure FormCreate(Sender: TObject);
      procedure PaintBoxPaint(Sender: TObject);
      procedure RegSaveBtnClick(Sender: TObject);
      procedure BlancBtnClick(Sender: TObject);
      procedure SpectreBtnClick(Sender: TObject);
      procedure FormActivate(Sender: TObject);
      procedure FormDestroy(Sender: TObject);
      procedure FormClose(Sender: TObject; var Action: TCloseAction);
      procedure BornesChange(Sender: TObject);
      procedure StopBtnClick(Sender: TObject);
      procedure ResetBtnClick(Sender: TObject);
      procedure UndoBtnClick(Sender: TObject);
      procedure ReticuleBtnClick(Sender: TObject);
      procedure PaintBoxMouseMove(Sender: TObject; Shift: TShiftState; X, Y: integer);
      procedure SpectreGridDrawCell(Sender: TObject; ACol, ARow: integer;
         Rect: TRect; State: TGridDrawState);
      procedure SpectreGridSetEditText(Sender: TObject; ACol, ARow: integer;
         const Value: string);
      procedure Edit1KeyPress(Sender: TObject; var Key: char);
      procedure PrintBtnClick(Sender: TObject);
      procedure RegressiMClick(Sender: TObject);
      procedure SaveBtnClick(Sender: TObject);
   private
      Etat:      TetatSpectre;
      oldValeur:       word;
      spectreSauve: boolean;
      graphe:    Tgraphe;
      triggerEsc:      word;
      blancFait, spectreFait: boolean;
      NbreCourant, NbreTotal: integer;
      pas250, Lambda0: integer;
      compteur:        integer;
      procedure setBoutonAcq;
      procedure TriggerData(CP: TObject; TriggerHandle: word);
      procedure SaveItem;
      procedure SpectreTrigger(CP: TObject; TriggerHandle: word);
      procedure SpectreAvail(CP: TObject; Count: word);
   public
   protected
   end;

var
   SpectreUviLine: TSpectreUviLine;

implementation

uses S250About, S250DDE, s250cst;

{$R *.DFM}

const
   pasLambda = 1;

procedure TSpectreUviLine.ExitItemClick(Sender: TObject);
begin
   Close;
end;

procedure TSpectreUviLine.SaveItem;
var
   fichier: textFile;

   procedure ecritEnTeteRW3;
   var
      c: indiceCourbe;
   begin with S250, graphe, constanteDlg do begin
         writeln(fichier, 'EVARISTE REGRESSI WINDOWS 1.0');
         writeln(fichier, symbReg, 1 + NbreCourbe, ' NOM VAR');
         writeln(fichier, CharLambda);
         if NbreCourbe = 1 then
            writeln(fichier, 'A')
         else
            for c := 1 to NbreCourbe do
               writeln(fichier, 'A' + IntToStr(c));
         writeln(fichier, symbReg, 1 + NbreCourbe, ' UNITE VAR');
         writeln(fichier, 'nm');
         for c := 1 to NbreCourbe do
            writeln(fichier, '');
         writeln(fichier, symbReg, 1 + NbreCourbe, ' SIGNIF VAR');
         writeln(fichier, 'Longueur d''onde');
         for c := 1 to NbreCourbe do
            writeln(fichier, 'Absorbance');
         if AvecConstante then begin
            writeln(fichier, symbReg, '1 NOM CONST');
            writeln(fichier, NomConstEdit.Text);
            writeln(fichier, symbReg, '1 UNITE CONST');
            writeln(fichier, UniteConstEdit.Text);
            writeln(fichier, symbReg, '1 SIGNIF CONST');
            writeln(fichier, SignifConstEdit.Text);
         end;
         writeln(fichier, symbReg, '1 ACQUISITION');
         writeln(fichier, Application.ExeName);
      end;
   end; { ecritEnTeteRW3 }

   procedure EcritPageRW3;
   var
      j: indiceVecteur;
      c: indiceCourbe;
   begin with graphe do begin
         writeln(fichier, symbReg, 1, ' PAGE COMMENT');
         if constanteDlg.editComm.Text = '' then
            writeln(fichier, DateTimeToStr(date + time))
         else
            writeln(fichier, constanteDlg.editComm.Text);
         writeln(fichier, symbReg2, NbreSpectre, ' VALEUR VAR');
         for j := 0 to maxVecteur do
            if valeurX[j] > 0 then begin
               Write(fichier, IntToStr(round(valeurX[j])));
               for c := 1 to NbreCourbe do
                  Write(fichier, ' ',
                     FloatToStrPoint(valeurY[c, j]));
               writeln(fichier);
            end; { for j }
         if constanteDlg.AvecConstante then begin
            writeln(fichier, symbReg2, '1 VALEUR CONST');
            writeln(fichier, constanteDlg.ValeurConstEdit.Text);
         end;
      end;
   end; {ecritPageRW3}

   procedure EcritTableur;
   var
      j: indiceVecteur;
      c: indiceCourbe;
   begin with graphe do begin
         writeln(fichier, 'Spectre  ' + DateTimeToStr(date + time));
         Write(fichier, 'lambda');
         if NbreCourbe = 1 then
            Write(fichier, crTab, 'A')
         else
            for c := 1 to NbreCourbe do
               Write(fichier, crTab, 'A' + IntToStr(c));
         writeln(fichier);
         Write(fichier, 'nm');
         for c := 1 to NbreCourbe do
            Write(fichier, crTab, ' ');
         writeln(fichier);
         writeln(fichier, constanteDlg.editComm.Text);
         for j := 0 to maxVecteur do
            if valeurX[j] > 0 then begin
               Write(fichier, IntToStr(round(valeurX[j])));
               for c := 1 to NbreCourbe do
                  Write(fichier, crTab, FloatToStrPoint(valeurY[c, j]));
               writeln(fichier);
            end;
         with constanteDlg do
            if avecConstante then
               writeln(fichier, NomConstEdit.Text, ValeurConstEdit.Text, UniteConstEdit.Text);
      end;
   end; {ecritTableur}

var
   formatRW3: boolean;
begin
   SaveDialog.Filter := 'Regressi (*.rw3)|*.rw3|Tableur ASCII (*.txt)|*.txt';
   if SaveDialog.Execute then begin
      FormatRW3 := AnsiUpperCase(ExtractFileExt(saveDialog.FileName)) = '.RW3';
      spectreSauve := True;
      AssignFile(fichier, saveDialog.FileName);
      Rewrite(fichier);
      if formatRW3 then begin
         ecritEnTeteRW3;
         ecritPageRW3;
      end
      else
         ecritTableur;
      CloseFile(fichier);
   end;
end;

procedure TSpectreUviLine.FormCreate(Sender: TObject);
var
   regini: TmemIniFile;
begin
   Graphe := Tgraphe.Create;
   with graphe, S250 do begin
      nbreCourbe := 0;
      mondeX.unite := 'nm';
      mondeX.nom := LettreLambda;
      mondeX.signif := 'Longueur d''onde';
      mondeY.nom := 'A';
      mondeY.unite := '';
      mondeY.signif := 'Absorbance';
      setMonde(MiniLambda, 0, MaxiLambda, MaxiAbs);
      Trace := tSpectre;
   end;
   DebutSE.MinValue := S250.MiniLambda;
   DebutSE.Enabled := True;
   FinSE.MaxValue := S250.MaxiLambda;
   FinSE.Enabled := True;
   graphe.NbrePoints := 0;
   try
      RegIni := tMemIniFile.Create(NomFichierIni);
      regressiM.Checked := regIni.ReadBool('Save', 'Regressi', True);
      if regressiM.Checked then
         saveBtn.ImageIndex := regressiM.imageIndex;
      clipM.Checked := regIni.ReadBool('Save', 'Clip', False);
      if clipM.Checked then
         saveBtn.ImageIndex := clipM.imageIndex;
      fileM.Checked := regIni.ReadBool('Save', 'File', False);
      if fileM.Checked then
         saveBtn.ImageIndex := fileM.imageIndex;
      regIni.Free;
   except
   end;
end;

procedure TSpectreUviLine.PaintBoxPaint(Sender: TObject);
var
   maxA: double;
begin with graphe do begin
      Canvas := PaintBox.Canvas;
      limiteFenetre := PaintBox.clientRect;
      if NbreCourbe > 0 then begin
         MaxA := MaxiY(NbreCourbe);
         if maxA < 0.1 then
            maxA := 1;
         if NbreCourbe = 1 then
            MondeY.maxi := maxA
         else if MondeY.maxi < maxA then
            MondeY.maxi := maxA;
      end
      else
         MondeY.maxi := S250.maxiAbs;
      Draw;
      traceFiltres;
      if ReticuleBtn.down and ReticuleBtn.Visible then
         TraceReticule;
      TraceRef;
   end;
end;

procedure TSpectreUviLine.RegSaveBtnClick(Sender: TObject);
begin
   if constanteDlg.showModal = mrOk then begin
      SpectreSauve := True;
      FormDDE.EnvoieDonneesSpectre(graphe, True);
      constanteDlg.newPageCB.ItemIndex := 1;
   end;
end;

procedure TSpectreUviLine.SetBoutonAcq;
const
   hintLambda = 'Inactif|Pour modifier, cliquer sur le bouton RZ';
var
   spectreFait: boolean;
begin
   spectreFait := graphe.NbreCourbe > 0;
   SaveBtn.Enabled := spectreFait;
   SpectreBtn.Enabled := blancFait and (etat = esAttente);
   PanelLambda.Visible := etat <> esAttente;
   BlancBtn.Enabled := etat = esAttente;
   DebutSE.Enabled := etat = esAttente;
   FinSE.Enabled := etat = esAttente;
   PanelDuree.Caption := TimeToStr(EncodeDuree(
      (finSE.Value - debutSE.Value) * S250.IntervalGOTO));
   DebutSE.Enabled := not blancFait;
   FinSE.Enabled := DebutSE.Enabled;
   resetBtn.Visible := blancFait;
   undoBtn.Visible := spectreFait;
   reticuleBtn.Visible := spectreFait;
   SpectreGB.Visible := spectreFait;
   if SpectreGB.Visible then
      SpectreGrid.rowCount := succ(Graphe.NbreCourbe);
   if DebutSE.Enabled then begin
      LambdaGB.hint := '';
      DebutSE.hint := '';
      FinSE.hint := '';
   end
   else begin
      LambdaGB.hint := hintLambda;
      DebutSE.hint := hintLambda;
      FinSE.hint := hintLambda;
   end;
   PaintBox.refresh;
end;

procedure TSpectreUviLine.BlancBtnClick(Sender: TObject);
var
   i: integer;
   lambdaDebut,lambdaFin : word;
begin
   BlancFait := False;
   SpectreFait := False;
   spectreSauve := True;
   LambdaDebut := debutSE.Value;
   LambdaFin := finSE.Value;
   for i := LambdaDebut to LambdaFin do
      graphe.valeurX[i] := 0;
   FormMain.voieSerie.OnTriggerData := SpectreTrigger;
   TriggerEsc := FormMain.voieSerie.AddDataTrigger(crESC, True);
   SpectreBtn.Enabled := False;
   BlancBtn.Enabled := False;
   Screen.cursor := crHourGlass;
   PaintBox.hint := 'Blanc en cours';
   FormMain.voieSerie.Output :=
      crEsc + ansiChar('4') +
      ansichar(Hi(LambdaDebut)) + ansichar(Lo(LambdaDebut)) +
      ansichar(Hi(LambdaFin)) + ansichar(Lo(LambdaFin)) +
      ansichar(3) + ansichar(S250.vitesse) + ansichar(Hi(LambdaLampe)) +
      ansichar(Lo(LambdaLampe));
end;

procedure TSpectreUviLine.SpectreBtnClick(Sender: TObject);
var
   i: integer;
begin with graphe do begin
      if SpectreSauve and (NbreCourbe = 1) then { page suivante }
      else if NbreCourbe < NbreCourbeMax then
         Inc(graphe.NbreCourbe)
      else begin
         ShowMessage('Nombre maximal de courbes atteint');
         exit;
      end;
      compteur := 0;
      for i := debutSE.Value to FinSE.value do
         valeurY[NbreCourbe, i] := nan;
      NbreCourant := 0;
      Screen.cursor := crHourGlass;
      SpectreBtn.Enabled := False;
      BlancBtn.Enabled := False;
      PaintBox.hint := 'Lecture du spectre en cours';
      formMain.voieSerie.onTriggerAvail := spectreAvail;
      formMain.voieSerie.outPut := crESC + ansiChar('5');
   end;
end;

procedure TSpectreUviLine.FormActivate(Sender: TObject);
begin
   FormMain.voieSerie.OnTriggerData  := TriggerData;
   setBoutonAcq;
end;

procedure TSpectreUviLine.FormDestroy(Sender: TObject);
begin
   Graphe.Free;
end;

procedure TSpectreUviLine.FormClose(Sender: TObject; var Action: TCloseAction);
var
   regini: TmemIniFile;
begin
   if (graphe.NbreCourbe > 0) and not (SpectreSauve) and
      (MessageDlg('Sauvegarde', mtConfirmation, [mbYes, mbNo], 0) = idYes) then
      SaveBtnClick(Sender);
   try
      RegIni := tMemIniFile.Create(NomFichierIni);
      regIni.WriteBool('Save', 'Regressi', regressiM.Checked);
      regIni.WriteBool('Save', 'Clip', clipM.Checked);
      regIni.WriteBool('Save', 'File', fileM.Checked);
      regIni.UpdateFile;
      RegIni.Free;
   except
   end;
   FormMain.setMode(mNone);
end;

procedure TSpectreUviLine.TriggerData(CP: TObject; TriggerHandle: word);
begin
end;

procedure TSpectreUviLine.BornesChange(Sender: TObject);
begin
   DebutSE.MaxValue := FinSE.Value - 50;
   FinSE.MinValue := DebutSE.Value + 50;
   BlancFait := False;
   SetBoutonAcq;
end;

procedure TSpectreUviLine.StopBtnClick(Sender: TObject);
begin
   if (etat = esSpectreEnCours) and (graphe.NbreSpectre < 20) then
      Dec(graphe.NbreCourbe);
   etat := esAttente;
   setBoutonAcq;
end;

procedure TSpectreUviLine.ResetBtnClick(Sender: TObject);
var
   j: integer;
begin
   if MessageDlg('Suppression de tous les spectres', mtConfirmation, [mbOK, mbCancel], 0) =
      idOk then begin
      graphe.NbreCourbe := 0;
      SpectreSauve := True;
      for j := 0 to MaxVecteur do
         graphe.valeurX[j] := 0;
      setBoutonAcq;
      PaintBox.refresh;
   end;
end;

procedure TSpectreUviLine.UndoBtnClick(Sender: TObject);
begin
   if MessageDlg('Suppression du dernier spectre', mtConfirmation, [mbOK, mbCancel], 0) =
      idOk then begin
      Dec(graphe.NbreCourbe);
      UndoBtn.Visible  := graphe.NbreCourbe > 0;
      ResetBtn.Visible := graphe.NbreCourbe > 0;
      PaintBox.refresh;
   end;
end;

procedure TSpectreUviLine.ReticuleBtnClick(Sender: TObject);
begin
   Header.sections[1].Text := '';
   Header.sections[0].Text := '';
   graphe.TraceReticule;
end;

procedure TSpectreUviLine.PaintBoxMouseMove(Sender: TObject; Shift: TShiftState;
   X, Y: integer);
var
   Xr, Yr: double;
begin
   if ReticuleBtn.down and ReticuleBtn.Visible then
      with Graphe do begin
         TraceReticule; { efface }
         MondeXY(x, y, xr, yr);
         Header.sections[1].Text := ' A=' + FormatCourt(Yr) + ' ';
         Header.sections[0].Text := ' ' + CharLambda + '=' + FormatCourt(Xr) + ' nm';
         XReticule := X;
         YReticule := Y;
         TraceReticule; { marque }
      end;
end;

procedure TSpectreUviLine.SpectreGridDrawCell(Sender: TObject;
   ACol, ARow: integer; Rect: TRect; State: TGridDrawState);
begin
   if Arow > 0 then begin
      spectreGrid.canvas.Font.Color := CouleurCourbe[Arow];
      spectreGrid.canvas.TextOut(Rect.Left + 2, Rect.Top + 2, graphe.titre[Arow]);
   end;
end;

procedure TSpectreUviLine.SpectreGridSetEditText(Sender: TObject;
   ACol, ARow: integer; const Value: string);
begin
   if Arow > 0 then
      graphe.titre[Arow] := Value;
end;

procedure TSpectreUviLine.Edit1KeyPress(Sender: TObject; var Key: char);
begin
   if key = ' ' then
      if SpectreBtn.Enabled then
         spectreBtnClick(Sender)
      else if BlancBtn.Enabled then
         blancBtnClick(Sender);
   key := #0;
end;

procedure TSpectreUviLine.PrintBtnClick(Sender: TObject);
begin
   graphe.imprime;
end;

procedure TSpectreUviLine.RegressiMClick(Sender: TObject);
begin
   saveBtn.ImageIndex := (Sender as TmenuItem).imageIndex;
   (Sender as TmenuItem).Checked := True;
   SaveBtnClick(Sender);
end;

procedure TSpectreUviLine.SaveBtnClick(Sender: TObject);
begin
   if regressiM.Checked then
      if ConstanteDlg.showModal = mrOk then begin
         SpectreSauve := True;
         FormDDE.EnvoieDonneesSpectre(graphe, True);
         constanteDlg.newPageCB.ItemIndex := 1;
      end;
   if clipM.Checked then begin
      SpectreSauve := True;
      FormDDE.EnvoieDonneesSpectre(graphe, False);
   end;
   if fileM.Checked then
      SaveItem;
end;

procedure TSpectreUviLine.SpectreTrigger(CP: TObject; TriggerHandle: word);
begin
   if triggerHandle = TriggerESC then begin
      BlancFait := True;
      FormMain.voieSerie.removeTrigger(TriggerESC);
      TriggerEsc := 0;
      FormMain.voieSerie.OnTriggerData := nil;
      setBoutonAcq;
   end;
end;

procedure TSpectreUviLine.SpectreAvail(CP: TObject; Count: word);
var
   i: integer;
   key: ansichar;
   lambda, valInt: word;
begin
   for i := 1 to Count do
      if FormMain.VoieSerie.CharReady then begin
         key := FormMain.VoieSerie.GetChar;
         valInt := Ord(key);
         Inc(compteur);
         case compteur of
            1, 2: ; // esc A
            3: lambda0 := valInt * 256;
            4: lambda0 := lambda0 + valInt;
            5: NbreTotal := valInt * 256;
            6: NbreTotal := NbreTotal + valInt;
            7: begin
               pas250 := valInt;
               paintBox.hint := 'Rcupration des donnes';
            end;
             // ensuite Nbre valeurs sur 2 octets
            else begin
               if compteur mod 2 = 0 then
                  oldValeur := valInt
               else with graphe do begin
                     Lambda := Lambda0 + NbreCourant * pasLambda;
                     valeurY[NbreCourbe, Lambda] := S250.WordToAbs(oldValeur, valInt);
                     valeurX[Lambda] := Lambda;
                     Inc(NbreCourant);
                     if NbreCourant = NbreTotal then begin
                        formMain.voieSerie.onTriggerAvail := formMain.VoieSerieTriggerAvail;
                        SpectreSauve := False;
                        SpectreFait  := True;
                        setBoutonAcq;
                        paintBox.refresh;
                     end; {if}
                  end; // compteur impair
            end;
         end;
      end;
end;

end.

