unit S250auto;

interface

uses Windows, Classes, Graphics, Forms, Controls, Menus,
   Dialogs, StdCtrls, Buttons, ExtCtrls, SysUtils, Messages,
   clipBrd, spin, Printers, inifiles, Grids, ComCtrls, ToolWin,
   ADport, adexcept, oomisc, math,
   S250cfg, graphker, jmmUtil;

type
   pseudoWord = record
      case boolean of
         False: (octets: array[0..1] of char);
         True: (mot: word);
   end;

   TSpectreForm = class(TForm)
      SaveDialog:    TSaveDialog;
      PaintBox:      TPaintBox;
      PanelBoutons:  TPanel;
      StartBtn:      TSpeedButton;
      BlancBtn:      TBitBtn;
      SpectreBtn:    TBitBtn;
      SpectreGB:     TGroupBox;
      SpectreGrid:   TStringGrid;
      Edit1:         TEdit;
      Header:        THeaderControl;
      ToolBar1:      TToolBar;
      SaveBtn:       TToolButton;
      ReticuleBtn:   TToolButton;
      ResetBtn:      TToolButton;
      UndoBtn:       TToolButton;
      SavePopupMenu: TPopupMenu;
      RegressiM:     TMenuItem;
      ClipM:         TMenuItem;
      FileM:         TMenuItem;
      PrintBtn:      TToolButton;
      ExitBtn0:      TToolButton;
      procedure ExitItemClick(Sender: TObject);
      procedure FormCreate(Sender: TObject);
      procedure PaintBoxPaint(Sender: TObject);
      procedure RegressiItemClick(Sender: TObject);
      procedure BlancBtnClick(Sender: TObject);
      procedure SpectreBtnClick(Sender: TObject);
      procedure ReticuleBtnClick(Sender: TObject);
      procedure PaintBoxMouseMove(Sender: TObject; Shift: TShiftState; X, Y: integer);
      procedure FormClose(Sender: TObject; var Action: TCloseAction);
      procedure FormDestroy(Sender: TObject);
      procedure StopBtnClick(Sender: TObject);
      procedure SpectreGridDrawCell(Sender: TObject; ACol, ARow: integer;
         Rect: TRect; State: TGridDrawState);
      procedure SpectreGridSetEditText(Sender: TObject; ACol, ARow: integer;
         const Value: string);
      procedure UndoBtnClick(Sender: TObject);
      procedure ResetBtnClick(Sender: TObject);
      procedure Edit1KeyPress(Sender: TObject; var Key: char);
      procedure PrintBtnClick(Sender: TObject);
      procedure SaveBtnClick(Sender: TObject);
      procedure RegressiMClick(Sender: TObject);
   private
      compteur:        integer;
      pas250, Lambda0: integer;
      NbreCourant, NbreTotal: integer;
      oldValeur:       word;
      triggerEsc:      word;
      blancFait, spectreFait: boolean;
      SpectreSauve:    boolean;
      procedure setBoutonAcq;
      procedure sauveSpectre;
      procedure SpectreAvail(CP: TObject; Count: word);
      procedure SpectreTrigger(CP: TObject; TriggerHandle: word);
   public
      Graphe: Tgraphe;
   protected
   end;

var
   SpectreForm: TSpectreForm;

implementation

uses S250About, S250DDE, s250cst, S250main;

const
   pasLambda = 1;

{$R *.DFM}

procedure TSpectreForm.ExitItemClick(Sender: TObject);
begin
   Close;
end;

procedure TSpectreForm.SauveSpectre;
var
   fichier: textFile;

   procedure ecritEnTeteRW3;
   var
      c: integer;
   begin with graphe, S250, constanteDlg do begin
         writeln(fichier, 'EVARISTE REGRESSI WINDOWS 1.0');
         writeln(fichier, symbReg, 1 + NbreCourbe, ' NOM VAR');
         writeln(fichier, CharLambda);
         if NbreCourbe > 1 then
            for c := 1 to NbreCourbe do
               writeln(fichier, 'A' + IntToStr(c))
         else
            writeln(fichier, 'A');
         writeln(fichier, symbReg, 1 + NbreCourbe, ' UNITE VAR');
         writeln(fichier, 'nm');
         for c := 1 to NbreCourbe do
            writeln(fichier, '');
         writeln(fichier, symbReg, 1 + NbreCourbe, ' SIGNIF VAR');
         writeln(fichier, 'Longueur d''onde');
         for c := 1 to NbreCourbe do
            writeln(fichier, 'Absorbance');
         if AvecConstante then begin
            writeln(fichier, symbReg, '1 NOM CONST');
            writeln(fichier, NomConstEdit.Text);
            writeln(fichier, symbReg, '1 UNITE CONST');
            writeln(fichier, UniteConstEdit.Text);
            writeln(fichier, symbReg, '1 SIGNIF CONST');
            writeln(fichier, SignifConstEdit.Text);
         end;
         writeln(fichier, symbReg, '1 ACQUISITION');
         writeln(fichier, Application.ExeName);
      end;
   end; // ecritEnTeteRW3

   procedure EcritPageRW3;
   var
      j: indiceVecteur;
      c: integer;
   begin
      with graphe, S250 do begin
         writeln(fichier, symbReg, 1, ' PAGE COMMENT');
         if constanteDlg.editComm.Text = '' then
            writeln(fichier, DateTimeToStr(date + time))
         else
            writeln(fichier, constanteDlg.editComm.Text);
         writeln(fichier, symbReg2, succ(LambdaFiltreUV - LambdaFiltreIR), ' VALEUR VAR');
         for j := LambdaFiltreIR to LambdaFiltreUV do begin
            Write(fichier, IntToStr(round(valeurX[j])));
            for c := 1 to NbreCourbe do
               Write(fichier, ' ',
                  FloatToStrPoint(valeurY[c, j]));
            writeln(fichier);
         end; { for j }
         if constanteDlg.AvecConstante then begin
            writeln(fichier, symbReg2, 1, ' VALEUR CONST');
            writeln(fichier, constanteDlg.ValeurConstEdit.Text);
         end;
      end;
   end; // ecritPageRW3

   procedure EcritTableur;
   var
      j: indiceVecteur;
      c: integer;
   begin with graphe do begin
         writeln(fichier, 'Spectre  ' + DateTimeToStr(date + time));
         writeln(fichier, constanteDlg.editComm.Text);
         Write(fichier, 'lambda');
         if NbreCourbe > 1 then
            for c := 1 to NbreCourbe do
               Write(fichier, crTab, 'A', IntToStr(c))
         else
            Write(fichier, crTab, 'A');
         writeln(fichier);
         Write(fichier, 'nm');
         for c := 1 to NbreCourbe do
            Write(fichier, crTab, '');
         writeln(fichier);
         for j := S250.LambdaFiltreIR to S250.LambdaFiltreUV do begin
            Write(fichier, IntToStr(round(valeurX[j])));
            for c := 1 to NbreCourbe do
               Write(fichier, crTab, FloatToStrPoint(valeurY[c, j]));
            writeln(fichier);
         end;
         with constanteDlg do
            if AvecConstante then
               writeln(fichier, NomConstEdit.Text, ValeurConstEdit.Text, UniteConstEdit.Text);
      end;
   end; // ecritTableur

var
   formatRW3: boolean;
begin
   SaveDialog.Filter := 'Regressi (*.rw3)|*.rw3|Tableur ASCII (*.txt)|*.txt';
   if SaveDialog.Execute then begin
      SpectreSauve := True;
      FormatRW3 := AnsiUpperCase(ExtractFileExt(saveDialog.FileName)) = '.RW3';
      AssignFile(fichier, saveDialog.FileName);
      Rewrite(fichier);
      if formatRW3 then begin
         ecritEnTeteRW3;
         ecritPageRW3;
      end
      else
         ecritTableur;
      CloseFile(fichier);
   end;
end;

procedure TSpectreForm.FormCreate(Sender: TObject);
var
   i: integer;
   regini: TmemIniFile;
begin
   Graphe := Tgraphe.Create;
   graphe.trace := tSpectre;
   blancFait := False;
   spectreFait := False;
   TriggerEsc := 0;
   spectreSauve := False;
   with graphe do begin
      mondeX.unite := 'nm';
      mondeX.nom := CharLambda;
      mondeX.signif := 'Longueur d''onde';
      mondeY.nom := 'A';
      mondeY.unite := '';
      mondeY.signif := 'Absorbance';
      with S250 do
         setMonde(LambdaFiltreIR, 0, LambdaFiltreUV, MaxiAbs);
      minRef := 0;
      maxRef := 0;
      for i := 0 to maxVecteur do
         valeurX[i] := 0;
      NbreCourbe := 0;
   end;
   graphe.canvas := PaintBox.Canvas;
   SpectreGrid.cells[1, 0] := 'Commentaire';
   Caption := 'Trac automatique de spectre avec Secomam S250PC (' +
      IntToStr(s250.LambdaFiltreIR) + '  ' + IntToStr(s250.LambdaFiltreUV) + ' nm)';
   try
      RegIni := tMemIniFile.Create(NomFichierIni);
      regressiM.Checked := regIni.ReadBool('Save', 'Regressi', True);
      if regressiM.Checked then
         saveBtn.ImageIndex := regressiM.imageIndex;
      clipM.Checked := regIni.ReadBool('Save', 'Clip', False);
      if clipM.Checked then
         saveBtn.ImageIndex := clipM.imageIndex;
      fileM.Checked := regIni.ReadBool('Save', 'File', False);
      if fileM.Checked then
         saveBtn.ImageIndex := fileM.imageIndex;
      regIni.Free;
   except
   end;
   setBoutonAcq;
end;

procedure TSpectreForm.PaintBoxPaint(Sender: TObject);
var
   absMax: double;
   i: integer;
begin with graphe do begin
      limiteFenetre := PaintBox.clientRect;
      for i := 0 to pred(header.sections.Count) do
         Header.sections[i].Text := '';
      PaintBox.hint := '';
      if NbreCourbe > 0 then begin
         AbsMax := MaxiY(NbreCourbe);
         if AbsMax < 0.1 then
            AbsMax := S250.MaxiAbs;
         if (NbreCourbe = 1) or (MondeY.maxi < AbsMax) then
            MondeY.maxi := AbsMax*1.05;
      end
      else
         MondeY.maxi := S250.maxiAbs;
      draw;
      if ReticuleBtn.down and ReticuleBtn.Visible then
         TraceReticule;
   end;
end;

procedure TSpectreForm.RegressiItemClick(Sender: TObject);
begin
   FormDDE.Execute(eFOCUS);
end;

procedure TSpectreForm.SetBoutonAcq;
var
   i: integer;
begin
   SaveBtn.Visible  := spectreFait;
   PrintBtn.Visible := spectreFait;
   SpectreBtn.Visible := BlancFait;
   SpectreBtn.Enabled := BlancFait;
   BlancBtn.Enabled := True;
   reticuleBtn.Visible := spectreFait;
   for i := 0 to pred(header.sections.Count) do
      Header.sections[i].Text := '';
   SpectreGrid.Visible := SpectreFait;
   ResetBtn.Visible := graphe.NbreCourbe > 0;
   UndoBtn.Visible  := graphe.NbreCourbe > 0;
   SpectreGB.Visible := graphe.NbreCourbe > 1;
   if SpectreGB.Visible then
      SpectreGrid.rowCount := succ(Graphe.NbreCourbe);
   Screen.cursor := crDefault;
end;

procedure TSpectreForm.BlancBtnClick(Sender: TObject);
var
   i: integer;
begin
   BlancFait := False;
   SpectreFait := False;
   spectreSauve := True;
   for i := S250.LambdaFiltreIR to S250.LambdaFiltreUV do
      graphe.valeurX[i] := 0;
   FormMain.voieSerie.OnTriggerData := SpectreTrigger;
   TriggerEsc := FormMain.voieSerie.AddDataTrigger(crESC, True);
   SpectreBtn.Enabled := False;
   BlancBtn.Enabled := False;
   Screen.cursor := crHourGlass;
   PaintBox.hint := 'Blanc en cours';
   FormMain.voieSerie.Output :=
      crEsc + ansiChar('4') +
      ansichar(Hi(S250.LambdaFiltreIR)) + ansichar(Lo(S250.LambdaFiltreIR)) +
      ansichar(Hi(S250.LambdaFiltreUV)) + ansichar(Lo(S250.LambdaFiltreUV)) +
      ansichar(3) + ansichar(S250.vitesse) + ansichar(Hi(LambdaLampe)) +
      ansichar(Lo(LambdaLampe));
end;

procedure TSpectreForm.SpectreBtnClick(Sender: TObject);
var i: integer;
begin with graphe do begin
      if SpectreSauve and (NbreCourbe = 1) then { page suivante }
      else if NbreCourbe < NbreCourbeMax then
         Inc(graphe.NbreCourbe)
      else begin
         ShowMessage('Nombre maximal de courbes atteint');
         exit;
      end;
      compteur := 0;
      for i := S250.LambdaFiltreIR to S250.LambdaFiltreUV do
         valeurY[NbreCourbe, i] := nan;
      NbreCourant := 0;
      Screen.cursor := crHourGlass;
      SpectreBtn.Enabled := False;
      BlancBtn.Enabled := False;
      PaintBox.hint := 'Lecture du spectre en cours';
      formMain.voieSerie.onTriggerAvail := spectreAvail;
      formMain.voieSerie.outPut := crESC + ansiChar('5');
   end;
end;

procedure TSpectreForm.ReticuleBtnClick(Sender: TObject);
var
   i: integer;
begin
   for i := 0 to pred(Header.sections.Count) do
      Header.sections[i].Text := '';
   graphe.TraceReticule;
end;

procedure TSpectreForm.PaintBoxMouseMove(Sender: TObject; Shift: TShiftState;
   X, Y: integer);
var
   Xr, Yr: double;
   i: integer;
   c: indiceCourbe;
begin
   if ReticuleBtn.down and ReticuleBtn.Visible then
      with Graphe do begin
         TraceReticule; { efface }
         MondeXY(x, y, xr, yr);
         for i := succ(S250.LambdaFiltreIR) to S250.LambdaFiltreUV do
            if (valeurX[pred(i)] < xr) and (valeurX[i] >= xr) then begin
               yr := valeurY[1, i];
               xr := valeurX[i];
               break;
            end;
         windowXY(xr, yr, x, y);
         XReticule := X;
         YReticule := Y;
         Header.sections[1].Text := ' A=' + FormatCourt(Yr) + ' ';
         Header.sections[0].Text := ' ' + CharLambda + '=' + FormatCourt(Xr) + ' nm';
         if NbreCourbe = 1 then
            Header.sections[1].Text := ' A=' + FormatCourt(Yr) + ' '
         else
            for c := 1 to NbreCourbe do
               Header.sections[c].Text :=
                  ' A' + IntToStr(c) + '=' + FormatCourt(valeurY[c, i]) + ' ';
         TraceReticule; { marque }
      end;
end;

procedure TSpectreForm.FormClose(Sender: TObject; var Action: TCloseAction);
var
   regini: TmemIniFile;
begin
   stopBtnClick(Sender);
   if (graphe.valeurX[S250.LambdaFiltreIR] > 0) and not
      SpectreSauve and (MessageDlg('Sauvegarde', mtConfirmation, [mbYes, mbNo], 0) =
      idYes) then
      SauveSpectre;
   try
      RegIni := tMemIniFile.Create(NomFichierIni);
      regIni.WriteBool('Save', 'Regressi', regressiM.Checked);
      regIni.WriteBool('Save', 'Clip', clipM.Checked);
      regIni.WriteBool('Save', 'File', fileM.Checked);
      regIni.UpdateFile;
      RegIni.Free;
   except
   end;
   FormMain.setMode(mNone);
end;

procedure TSpectreForm.SpectreAvail(CP: TObject; Count: word);
var
   i: integer;
   key: ansichar;
   lambda, valInt: word;
begin
   for i := 1 to Count do
      if FormMain.VoieSerie.CharReady then begin
         try
            key := FormMain.VoieSerie.GetChar;
         except
            continue;// ne devrait pas arriver mais arrive
         end;
         valInt := Ord(key);
         Inc(compteur);
         case compteur of
            1, 2: ; { esc A }
            3: lambda0 := valInt * 256;
            4: lambda0 := lambda0 + valInt;
            5: NbreTotal := valInt * 256;
            6: NbreTotal := NbreTotal + valInt;
            7: begin
               pas250 := valInt;
               paintBox.hint := 'Rcupration des donnes';
            end;
             // ensuite Nbre valeurs sur 2 octets
            else begin
               if compteur mod 2 = 0 then
                  oldValeur := valInt
               else with graphe do begin
                     Lambda := Lambda0 + NbreCourant * pasLambda;
                     valeurY[NbreCourbe, Lambda] := S250.WordToAbs(oldValeur, valInt);
                     valeurX[Lambda] := Lambda;
                     Inc(NbreCourant);
                     if NbreCourant = NbreTotal then begin
                        formMain.voieSerie.onTriggerAvail := formMain.VoieSerieTriggerAvail;
                        SpectreSauve := False;
                        SpectreFait  := True;
                        setBoutonAcq;
                        paintBox.refresh;
                     end; {if}
                  end; {with}
            end;
         end;
      end;
end;

procedure TSpectreForm.SpectreTrigger(CP: TObject; TriggerHandle: word);
begin
   if triggerHandle = TriggerESC then begin
      BlancFait := True;
      FormMain.voieSerie.removeTrigger(TriggerESC);
      TriggerEsc := 0;
      FormMain.voieSerie.OnTriggerData := nil;
      setBoutonAcq;
   end;
end;

procedure TSpectreForm.FormDestroy(Sender: TObject);
begin
   graphe.Free;
end;

procedure TSpectreForm.StopBtnClick(Sender: TObject);
begin
   if triggerEsc <> 0 then
      FormMain.voieSerie.removeTrigger(TriggerESC);
   formMain.voieSerie.onTriggerAvail := formMain.VoieSerieTriggerAvail;
end;

procedure TSpectreForm.SpectreGridDrawCell(Sender: TObject;
   ACol, ARow: integer; Rect: TRect; State: TGridDrawState);
begin
   if Arow > 0 then begin
      spectreGrid.canvas.Font.Color := CouleurCourbe[Arow];
      spectreGrid.canvas.TextOut(Rect.Left + 2, Rect.Top + 2, graphe.titre[Arow]);
   end;
end;

procedure TSpectreForm.SpectreGridSetEditText(Sender: TObject;
   ACol, ARow: integer; const Value: string);
begin
   if Arow > 0 then
      graphe.titre[Arow] := Value;
end;

procedure TSpectreForm.UndoBtnClick(Sender: TObject);
begin
   if MessageDlg('Suppression du dernier spectre', mtConfirmation, [mbOK, mbCancel], 0) =
      idOk then begin
      Dec(graphe.NbreCourbe);
      UndoBtn.Visible  := graphe.NbreCourbe > 0;
      ResetBtn.Visible := graphe.NbreCourbe > 0;
      PaintBox.refresh;
      SpectreFait := graphe.NbreCourbe > 0;
   end;
end;

procedure TSpectreForm.ResetBtnClick(Sender: TObject);
begin
   if MessageDlg('Suppression de tous les spectres', mtConfirmation, [mbOK, mbCancel], 0) =
      idOk then begin
      graphe.NbreCourbe := 0;
      SpectreSauve := True;
      SpectreFait  := False;
      PaintBox.refresh;
      setBoutonAcq;
   end;
end;

procedure TSpectreForm.Edit1KeyPress(Sender: TObject; var Key: char);
begin
   if key = ' ' then
      if SpectreBtn.Enabled then
         spectreBtnClick(Sender)
      else if BlancBtn.Enabled then
         blancBtnClick(Sender);
   key := #0;
end;

procedure TSpectreForm.PrintBtnClick(Sender: TObject);
begin
   graphe.imprime;
end;

procedure TSpectreForm.SaveBtnClick(Sender: TObject);
begin
   if regressiM.Checked then
      if ConstanteDlg.showModal = mrOk then begin
         SpectreSauve := True;
         FormDDE.EnvoieDonneesSpectre(graphe, True);
         constanteDlg.newPageCB.ItemIndex := 1;
      end;
   if clipM.Checked then begin
      SpectreSauve := True;
      FormDDE.EnvoieDonneesSpectre(graphe, False);
   end;
   if fileM.Checked then
      SauveSpectre;
end;

procedure TSpectreForm.RegressiMClick(Sender: TObject);
begin
   saveBtn.ImageIndex := (Sender as TmenuItem).imageIndex;
   (Sender as TmenuItem).Checked := True;
   SaveBtnClick(Sender);
end;

end.

