unit S250beer;

interface

uses Windows, Classes, Graphics, Forms, Controls, Menus,
   Dialogs, StdCtrls, Buttons, ExtCtrls, SysUtils, Messages, clipBrd,
   spin, Grids, inifiles, ComCtrls, ToolWin,
   ADport, ADexcept, oomisc, math,
   graphker, jmmUtil, S250cfg;

type
   TModeAcquisition = (maIncrement, maClavier);

   TBeerForm = class(TForm)
      SaveDialog:     TSaveDialog;
      BoutonsPanel:   TPanel;
      Panel1:         TPanel;
      LabelPb:        TLabel;
      Oscillo:        TPaintBox;
      ClavierEdit:    TEdit;
      LabelClavier:   TLabel;
      BeerMesureGrid: TStringGrid;
      beerCalcGrid:   TStringGrid;
      LambdaSE:       TSpinEdit;
      Label2:         TLabel;
      Timer:          TTimer;
      ToolBar1:       TToolBar;
      SaveBtn:        TToolButton;
      ModeBtn0:       TToolButton;
      ResetBtn:       TToolButton;
      UndoBtn:        TToolButton;
      EnregistreBtn:  TToolButton;
      MajBtn:         TToolButton;
      ZeroBtn:        TToolButton;
      ExitBtn0:       TToolButton;
      PrintBtn0:      TToolButton;
      SavePopupMenu:  TPopupMenu;
      RegressiM:      TMenuItem;
      ClipM:          TMenuItem;
      FileM:          TMenuItem;
      BeerCalcCB:     TCheckBox;
      procedure ExitItemClick(Sender: TObject);
      procedure AboutItemClick(Sender: TObject);
      procedure FormCreate(Sender: TObject);
      procedure InitAttente;
      procedure AcquisitionItemClick(Sender: TObject);
      procedure OscilloPaint(Sender: TObject);
      procedure StopBtnClick(Sender: TObject);
      procedure ResetBtnClick(Sender: TObject);
      procedure EnregistreEditKeyPress(Sender: TObject; var Key: char);
      procedure EnregistreBtnClick(Sender: TObject);
      procedure UndoBtnClick(Sender: TObject);
      procedure FormResize(Sender: TObject);
      procedure ClavierEditKeyPress(Sender: TObject; var Key: char);
      procedure LambdaSEChange(Sender: TObject);
      procedure TimerTimer(Sender: TObject);
      procedure MajBtnClick(Sender: TObject);
      procedure FormDestroy(Sender: TObject);
      procedure FormClose(Sender: TObject; var Action: TCloseAction);
      procedure FormActivate(Sender: TObject);
      procedure ZeroBtnClick(Sender: TObject);
      procedure PrintBtnClick(Sender: TObject);
      procedure BeerMesureGridSelectCell(Sender: TObject; ACol, ARow: integer;
         var CanSelect: boolean);
      procedure BeerMesureGridKeyPress(Sender: TObject; var Key: char);
      procedure BeerMesureGridSetEditText(Sender: TObject; ACol, ARow: integer;
         const Value: string);
      procedure FormKeyPress(Sender: TObject; var Key: char);
      procedure SaveBtnClick(Sender: TObject);
      procedure RegressiMClick(Sender: TObject);
   private
      DejaSauve:      boolean;
      NomFichierData: string;
      valeurCourante, valeurClavier: double;
      pente:          double;
      AbsCalc, ConcCalc: vecteur;
      NbreCalc:       integer;
      DernierPointCalc: boolean;
      { Calc : calcule par la loi de Beer Lambert }
      Hlambda:        integer;
      TitreEcart : string;
      procedure FinLambda;
      procedure setBoutonAcq;
      procedure TriggerData(CP: TObject; TriggerHandle: word);
      procedure MarquePoint(i: indiceVecteur);
      procedure EnvoieDonnees(DDE: boolean);
      procedure SaveItem;
   public
      ModeAcq: TmodeAcquisition;
      Graphe:  Tgraphe;
   protected
   end;

var
   BeerForm: TBeerForm;

implementation

uses S250About, S250DDE, S250main, modebeer, S250cst;

{$R *.DFM}

procedure TBeerForm.ExitItemClick(Sender: TObject);
begin
   Close;
end;

procedure TBeerForm.SaveItem;
var
   fichier: textFile;

   procedure EcritPageRW3;
   var
      j: integer;
   begin
      with graphe do
      begin
         writeln(fichier, symbReg, 1, ' PAGE COMMENT');
         writeln(fichier, 'Cintique' + DateTimeToStr(date + time));
         writeln(fichier, symbReg2, NbrePoints, ' VALEUR VAR');
         for j := 0 to pred(NbrePoints) do
         begin
            Write(fichier, FloatToStrPoint(valeurX[j]));
            Write(fichier, ' ', FloatToStrPoint(valeurY[1, j]));
            writeln(fichier);
         end; { for j }
      end;
   end; {ecritPageRW3}

   procedure EcritPageTableur;
   var
      j: integer;
   begin
      with graphe do
      begin
         for j := 0 to pred(NbrePoints) do
         begin
            Write(fichier, FloatToStrPoint(valeurX[j]));
            Write(fichier, crTab, FloatToStrPoint(valeurY[1, j]));
            writeln(fichier);
         end;
      end;
   end; {ecritPageTableur}

   procedure ecritEnTeteTableur;
   begin
      with graphe do
      begin
         writeln(fichier, 'Cintique');
         Write(fichier, mondeX.nom);
         Write(crTab, mondeY.nom);
         writeln(fichier);
         Write(fichier, mondeX.unite);
         Write(crTab, mondeY.Unite);
         writeln(fichier);
         Write(fichier, mondeX.signif);
         Write(crTab, mondeY.signif);
         writeln(fichier);
      end;
   end; { ecritEnTeteTableur }

   procedure ecritEnTeteRW3;
   begin
      with graphe do
      begin
         writeln(fichier, 'EVARISTE REGRESSI WINDOWS 1.0');
         writeln(fichier, symbReg, '2 NOM VAR');
         writeln(fichier, mondeX.nom);
         writeln(fichier, mondeY.nom);
         writeln(fichier, symbReg, '2 UNITE VAR');
         writeln(fichier, mondeX.unite);
         writeln(fichier, mondeY.Unite);
         writeln(fichier, symbReg, '2 SIGNIF VAR');
         writeln(fichier, mondeX.signif);
         writeln(fichier, mondeY.signif);
         writeln(fichier, symbReg, '1 ACQUISITION');
         writeln(fichier, Application.ExeName);
      end;
   end; { ecritEnTeteRW3 }

var
   formatRW3: boolean;
begin
   SaveDialog.filter := 'Regressi (*.rw3)|*.rw3|Tableur ASCII (*.txt)|*.txt';
   SaveDialog.defaultExt := 'RW3';
   if SaveDialog.Execute then
   begin
      FormatRW3 := ExtractFileExt(saveDialog.FileName) = '.RW3';
      NomFichierData := saveDialog.FileName;
      AssignFile(fichier, saveDialog.FileName);
      Rewrite(fichier);
      if formatRW3 then
      begin
         ecritEnTeteRW3;
         ecritPageRW3;
      end
      else
      begin
         ecritEnTeteTableur;
         ecritPageTableur;
      end;
      CloseFile(fichier);
      DejaSauve := True;
   end;
end;

procedure TBeerForm.AboutItemClick(Sender: TObject);
begin
   AboutBox.ShowModal;
end;

procedure TBeerForm.FormCreate(Sender: TObject);
var
   regini: TmemIniFile;
begin
   Hlambda := 0;
   DejaSauve := True;
   ModeAcq := maIncrement;
   Graphe  := Tgraphe.Create;
   with graphe.mondeY do
   begin
      nom  := 'A';
      unite := '';
      signif := 'Absorbance';
      mini := 0;
      maxi := 1;
   end;
   with graphe do
   begin
      Trace  := tPoint;
      limiteCourbe := Oscillo.clientRect;
      Canvas := Oscillo.Canvas;
      NbrePoints := 0;
   end;
   NbreCalc := 0;
   LambdaSE.MinValue := S250.miniLambda;
   LambdaSE.MaxValue := S250.maxiLambda;
   LambdaSE.Value := 500;
   BeerCalcGrid.font.color := couleurCalc;
   try
      RegIni := tMemIniFile.Create(NomFichierIni);
      regressiM.Checked := regIni.ReadBool('Save', 'Regressi', True);
      if regressiM.Checked then
         saveBtn.ImageIndex := regressiM.imageIndex;
      clipM.Checked := regIni.ReadBool('Save', 'Clip', False);
      if clipM.Checked then
         saveBtn.ImageIndex := clipM.imageIndex;
      fileM.Checked := regIni.ReadBool('Save', 'File', False);
      if fileM.Checked then
         saveBtn.ImageIndex := fileM.imageIndex;
      modeAcq := TmodeAcquisition(regIni.ReadInteger('Beer', 'Mode', 0));
      graphe.mondeX.maxi := regIni.ReadFloat('Beer', 'Maxi', 1);
      graphe.mondeX.nom  := regIni.ReadString('Beer', 'NomX', 'c');
      graphe.mondeX.signif := regIni.ReadString('Beer', 'SignifX', 'concentration');
      graphe.mondeX.unite := regIni.ReadString('Beer', 'UniteX', 'mol/L');
      graphe.mondeX.mini := 0;
      regIni.Free;
   except
   end;
end;

procedure TBeerForm.InitAttente;
var
   i: integer;
begin
   with graphe do
   begin
      ClavierEdit.Visible  := modeAcq = maClavier;
      BeerCalcGrid.Visible := BeerCalcCB.Checked;
      LabelClavier.Visible := ClavierEdit.Visible;
      case modeAcq of
         maIncrement:
         begin
            for i := 0 to Maxvecteur do
               valeurX[i] := i;
            mondeX.nom := 'n';
            mondeX.signif := 'numro';
            mondeX.unite := '';
            MondeX.Maxi := 16;
            MondeX.Mini := 0;
         end;
         maClavier: ;
      end;
      Oscillo.Refresh;
      SetBoutonAcq;
   end;
end; { InitAttente }

procedure TBeerForm.AcquisitionItemClick(Sender: TObject);
var
   oldMode: TmodeAcquisition;
begin
   oldMode := modeAcq;
   ModeBeerDlg.showModal;
   if oldMode <> modeAcq then
   begin
      graphe.NbrePoints := 0;
      NbreCalc := 0;
   end;
   initAttente;
end;

procedure TBeerForm.OscilloPaint(Sender: TObject);
var
   x0, y0, x1, y1, i, j: integer;
   AbsMax: double;
begin
   with graphe do
   begin
      limiteFenetre := Oscillo.clientRect;
      if NbrePoints > 0 then
      begin
         AbsMax := MaxiY(1);
         if AbsMax < 0.1 then
            AbsMax := 0.1;
         if (MondeY.Maxi < AbsMax) then
            MondeY.maxi := AbsMax;
         if modeAcq <> maIncrement then
         begin
            AbsMax := MaxiX;
            if (MondeX.Maxi < AbsMax) then
               MondeX.maxi := AbsMax;
         end;
      end
      else
      begin
         MondeY.maxi := 1;
      end;
      Draw;
      BeerMesureGrid.cells[0, 0] := mondeX.nom;
      BeerMesureGrid.cells[1, 0] := mondeY.nom;
      BeerMesureGrid.cells[0, 1] := mondeX.Unite;
      BeerMesureGrid.cells[1, 1] := mondeY.Unite;
      if BeerMesureGrid.rowCount < (NbrePoints + 3) then
         BeerMesureGrid.rowCount := NbrePoints + 3;
      i := 0;
      while i < NbrePoints do
      begin
         if valeurY[1, i] < 1e-6 then
         begin
            for j := i to (NbrePoints - 2) do
               valeurY[1, j] := valeurY[1, succ(j)];
            Dec(NbrePoints);
         end
         else
            Inc(i);
      end;
      for i := 0 to pred(NbrePoints) do
      begin
         BeerMesureGrid.cells[0, i + 2] := FormatCourt(valeurX[i]);
         BeerMesureGrid.cells[1, i + 2] := FormatCourt(valeurY[1, i]);
      end;
      if NbrePoints > 0 then
         BeerMesureGrid.row := NbrePoints + 1;
      for i := (NbrePoints + 2) to pred(BeermesureGrid.RowCount) do
      begin
         BeerMesureGrid.cells[0, i] := '';
         BeerMesureGrid.cells[1, i] := '';
      end;
      if BeerCalcCB.Checked and (NbrePoints > 2) then
      begin
         windowXY(0, 0, x0, y0);
         WindowXY(mondeX.maxi, MondeX.maxi * pente, x1, y1);
         if y1 < limiteFenetre.top then
            WindowXY(mondeY.maxi / pente, MondeY.maxi, x1, y1);
         Oscillo.canvas.moveTo(x0, y0);
         Oscillo.canvas.lineTo(x1, y1);
         if BeerCalcGrid.rowCount < (NbreCalc + 1) then
            BeerCalcGrid.rowCount := NbreCalc + 1;
         for i := 0 to pred(Nbrecalc) do
         begin
            BeerCalcGrid.cells[0, i] := FormatCourt(concCalc[i]);
            BeerCalcGrid.cells[1, i] := FormatCourt(absCalc[i]);
            tracePointBeer(concCalc[i], absCalc[i]);
         end;
         if NbreCalc > 0 then
            BeerCalcGrid.row := NbreCalc;
         for i := NbreCalc to pred(BeerCalcGrid.RowCount) do
         begin
            BeerCalcGrid.cells[0, i] := '';
            BeerCalcGrid.cells[1, i] := '';
         end;
      end;
   end;
end;

procedure TBeerForm.StopBtnClick(Sender: TObject);
begin
   if Graphe.NbrePoints > 2 then
      setBoutonAcq
   else
      ResetBtnClick(Sender);
end;

procedure TBeerForm.EnvoieDonnees(DDE: boolean);
var
   i: integer;
   donnees: TStringList;
begin
   with graphe do
   begin
      Donnees := TStringList.Create;
      Donnees.Add(Application.ExeName);
      Donnees.Add('Loi de Beer-Lambert ' + DateTimeToStr(date + time));
      Donnees.Add(ConstanteDlg.EditComm.Text);
      Donnees.Add(MondeX.nom + crTab + MondeY.nom);
      Donnees.Add(MondeX.unite + crTab + MondeY.unite);
      for i := 0 to pred(NbrePoints) do
      begin
         Donnees.Add(
            FloatToStrPoint(valeurX[i]) + crTab + FloatToStrPoint(valeurY[1, i]));
      end;
      if BeerCalcCB.Checked then
         for i := 0 to pred(NbreCalc) do
         begin
            Donnees.Add(
               FloatToStrPoint(concCalc[i]) + crTab + FloatToStrPoint(absCalc[i]));
         end;
      FormDDE.AjouteConst(donnees);
      ClipBoard.astext := donnees.Text;
      if DDE then
         if constanteDlg.newPageCB.ItemIndex = 1 then
            FormDDE.Execute(eADD)
         else
            FormDDE.Execute(eLOAD);
      donnees.Free;
      constanteDlg.newPageCB.ItemIndex := 1;
   end;
end;

procedure TBeerForm.SetBoutonAcq;
begin
   ResetBtn.Visible := graphe.NbrePoints > 2;
   SaveBtn.Visible  := ResetBtn.Visible;
   UndoBtn.Visible  := graphe.NbrePoints > 0;
   ClavierEdit.Text := '';
   LabelClavier.Caption :=
      graphe.mondeX.nom + ' (' + graphe.mondeX.unite + ') =';
   ClavierEdit.Visible := modeAcq in [maClavier];
   LabelClavier.Visible := ClavierEdit.Visible;
   EnregistreBtn.Visible := modeAcq = maIncrement;
   case ModeAcq of
      maClavier:
      begin
         ClavierEdit.SetFocus;
         ClavierEdit.Hint :=
            'Taper la valeur de ' + graphe.mondeX.nom +
            '. Valider pour lire l''absorbance';
         EnregistreBtn.Visible := (graphe.NbrePoints > 2) and BeerCalcCB.Checked;
         ClavierEdit.SetFocus;
         EnregistreBtn.Caption := 'C = ?';
         EnregistreBtn.hint := 'Cliquer pour dterminer une concentration inconnue';
      end;
      maIncrement:
      begin
         EnregistreBtn.Caption := 'Enregistrer';
         EnregistreBtn.hint := 'Cliquer pour enregistrer un point';
      end;
   end;
   EnregistreBtn.Enabled := EnregistreBtn.Visible;
end;

procedure TBeerForm.ResetBtnClick(Sender: TObject);
begin
   graphe.NbrePoints := 0;
   NbreCalc := 0;
   initAttente;
end;

procedure TBeerForm.EnregistreEditKeyPress(Sender: TObject; var Key: char);
begin
   if (key = ' ') and (modeAcq = maIncrement) and
      enregistreBtn.Visible and enregistreBtn.Enabled then
      enregistreBtnClick(Sender);
   key := #0;
end;

procedure TBeerForm.EnregistreBtnClick(Sender: TObject);
begin
   with graphe do
   begin
      valeurCourante := FormMain.getAbsorbance;
      if isnan(valeurCourante) then
         exit;
      case modeAcq of
         maIncrement:
         begin
            valeurY[1, NbrePoints] := valeurCourante;
            MarquePoint(NbrePoints);
            Inc(NbrePoints);
            if mondeX.maxi < NbrePoints + 16 then
            begin
               mondeX.maxi := mondeX.maxi + 16;
               oscillo.refresh;
            end;
         end;
         maClavier:
         begin
            absCalc[NbreCalc]  := valeurCourante;
            concCalc[NbreCalc] := valeurCourante / pente;
            if BeerCalcGrid.rowCount < (NbreCalc + 1) then
               BeerCalcGrid.rowCount := NbreCalc + 1;
            BeerCalcGrid.cells[0, NbreCalc] := FormatCourt(concCalc[NbreCalc]);
            BeerCalcGrid.cells[1, NbreCalc] := FormatCourt(valeurCourante);
            if NbreCalc > 0 then
               BeerCalcGrid.row := NbreCalc - 1;
            tracePointBeer(concCalc[NbreCalc], absCalc[NbreCalc]);
            Inc(NbreCalc);
            DernierPointCalc := True;
         end;
      end;
      setBoutonAcq;
      DejaSauve := graphe.NbrePoints < 2;
   end;
end;

procedure TBeerForm.UndoBtnClick(Sender: TObject);
begin
   { Supprimer dernier point }
   if graphe.NbrePoints > 0 then
      if (modeAcq = maClavier) and BeerCalcCB.Checked and dernierPointCalc then
         Dec(NbreCalc)
      else
         Dec(graphe.NbrePoints);
   Oscillo.refresh;
   EnregistreBtn.Visible := (modeAcq = maIncrement) or
      ((modeAcq = maClavier) and BeerCalcCB.Checked and (graphe.nbrePoints > 2));
end;

procedure TBeerForm.FormResize(Sender: TObject);
begin
   Graphe.limiteCourbe := Oscillo.clientRect;
end;

procedure TBeerForm.ClavierEditKeyPress(Sender: TObject; var Key: char);

   procedure EnregistrePointClavier;
   var
      i, Nbre: integer;
      AbsTot,cTot,ecart : double;
   begin
      with graphe do
      begin
         valeurX[NbrePoints] := valeurClavier;
         valeurCourante := FormMain.getAbsorbance;
         valeurY[1, NbrePoints] := valeurCourante;
         MarquePoint(NbrePoints);
         Inc(NbrePoints);
         SetBoutonAcq;
         TitreEcart := '';
         EnregistreBtn.Visible :=
            (modeAcq = maClavier) and BeerCalcCB.Checked and (graphe.NbrePoints > 2);
         if EnregistreBtn.Visible then
         begin
            pente := 0;
            AbsTot := 0;
            cTot := 0;
            Nbre  := 0;
            for i := 0 to pred(NbrePoints) do
               if (valeurX[i] > 1e-9) and (valeurY[1, i] > 1e-3) then
               begin
                  AbsTot := AbsTot + valeurY[1, i];
                  cTot := cTot+valeurX[i];
                  Inc(Nbre);
               end;
            if Nbre > 0 then
            begin
               pente := AbsTot / cTot;
               for i := 0 to pred(NbreCalc) do
                  concCalc[i] := pente * absCalc[i];
               ecart := 0;
               Nbre := 0;
               for i := 0 to pred(NbrePoints) do
                   if (valeurX[i]>1e-9) and
                      (valeurY[1,i]>1e-3) then begin
                      ecart := ecart+sqr(valeurY[1,i]-
                               pente*valeurX[i]);
                   inc(Nbre);
               end;
               ecart := sqrt(ecart/Nbre);
               TitreEcart := 'Ecart quadratique sur A : '+FormatCourt(ecart);
            end;
            oscillo.Refresh;
         end;
         ClavierEdit.Text := '';
         ClavierEdit.SetFocus;
         UndoBtn.Visible  := graphe.NbrePoints > 0;
         SaveBtn.Visible  := graphe.NbrePoints > 2;
         ResetBtn.Visible := SaveBtn.Visible;
         DernierPointCalc := False;
      end;
   end;

begin
   if key = crCR then
      with graphe.mondeX do
      begin
         try
            valeurClavier := StrToFloat(ClavierEdit.Text);
            if (valeurClavier > maxi) or (valeurClavier < 0) then
               if (MessageDlg(FormatCourt(valeurClavier) +
                  ' positive' + ' ; maxi=' +
                  FormatCourt(maxi) + #13#10 + '    Vous confirmez ?',
                  mtConfirmation, [mbYes, mbNo], 0) = mrNo) then
               begin
                  ClavierEdit.SetFocus;
                  exit;
               end
               else
               begin
                  if (valeurClavier > maxi) then
                     maxi := valeurClavier * 1.05;
                  oscillo.refresh;
               end;
            EnregistrePointClavier;
         except
            ValeurClavier := nan;
            ShowMessage('Nombre mal crit');
            ClavierEdit.Text := '';
            ClavierEdit.SetFocus;
         end;
         key := #0;
      end;
end;

procedure TBeerForm.LambdaSEChange(Sender: TObject);
begin
   MajBtn.Visible := True;
   Timer.Enabled  := True;
end;

procedure TBeerForm.TimerTimer(Sender: TObject);
begin
   if timer.interval <> 1000 then
      FinLambda
   else if MajBtn.imageIndex < 0 then
      MajBtn.imageIndex := 15
   else
      MajBtn.imageIndex := -1;
end;

procedure TBeerForm.MajBtnClick(Sender: TObject);
begin
   Timer.Enabled := False;
   FormMain.voieSerie.OnTriggerData := TriggerData;
   HLambda := FormMain.voieSerie.AddDataTrigger(crESC, False);
   Screen.cursor := crHourGlass;
   LambdaSE.Enabled := False;
   FormMain.setLambda(lambdaSE.Value);
   ClavierEdit.Enabled := False;
   EnregistreBtn.Enabled := False;
   ZeroBtn.Enabled := False;
   MajBtn.Visible := False;
   Timer.Interval := TimeOutMs;
   Timer.Enabled := True;
end;

procedure TBeerForm.TriggerData(CP: TObject; TriggerHandle: word);
begin
   if TriggerHandle = Hlambda then
      FinLambda;
end;

procedure TBeerForm.FinLambda;
begin
   if Hlambda <> 0 then
      FormMain.voieSerie.RemoveTrigger(Hlambda);
   Hlambda := 0;
   Screen.cursor := crDefault;
   ClavierEdit.Enabled := True;
   ZeroBtn.Enabled := True;
   LambdaSE.Enabled := True;
   Timer.Enabled := False;
   Timer.interval := 1000;
   EnregistreBtn.Enabled := EnregistreBtn.Visible;
end;

procedure TBeerForm.FormDestroy(Sender: TObject);
begin
   graphe.Free;
end;

procedure TBeerForm.FormClose(Sender: TObject; var Action: TCloseAction);
var
   regini: TmemIniFile;
begin
   if (graphe.NbrePoints > 2) and not DejaSauve and
      (MessageDlg('Sauvegarde', mtConfirmation, [mbYes, mbNo], 0) = idYes) then
      SaveBtnClick(Sender);
   Timer.Enabled := False;
   try
      RegIni := tMemIniFile.Create(NomFichierIni);
      regIni.WriteBool('Save', 'Regressi', regressiM.Checked);
      regIni.WriteBool('Save', 'Clip', clipM.Checked);
      regIni.WriteBool('Save', 'File', fileM.Checked);
      regIni.WriteInteger('Beer', 'Mode', Ord(modeAcq));
      if modeAcq <> maIncrement then
      begin
         regIni.WriteFloat('Beer', 'Maxi', graphe.mondeX.maxi);
         regIni.WriteString('Beer', 'NomX', graphe.mondeX.nom);
         regIni.WriteString('Beer', 'SignifX', graphe.mondeX.signif);
         regIni.WriteString('Beer', 'UniteX', graphe.mondeX.unite);
      end;
      regIni.UpdateFile;
      RegIni.Free;
   except
   end;
   FormMain.setMode(mNone);
end;

procedure TBeerForm.FormActivate(Sender: TObject);
begin
   InitAttente;
end;

procedure TBeerForm.MarquePoint(i: indiceVecteur);
begin
   graphe.traceUnPoint(i, 1);
   if BeerMesureGrid.rowCount < (i + 3) then
      BeerMesureGrid.rowCount := i + 3;
   BeerMesureGrid.cells[0, i + 2] := FormatCourt(graphe.valeurX[i]);
   BeerMesureGrid.cells[1, i + 2] := FormatCourt(graphe.valeurY[1, i]);
   BeerMesureGrid.row := i + 2;
end;

procedure TBeerForm.ZeroBtnClick(Sender: TObject);
var
   sauveMaj: boolean;
begin
   EnregistreBtn.Enabled := False;
   Timer.Enabled := False;
   sauveMaj := MajBtn.Enabled;
   MajBtn.Enabled := False;
   Application.ProcessMessages;
   FormMain.setZero;
   EnregistreBtn.Enabled := EnregistreBtn.Visible;
   MajBtn.Enabled := sauveMaj;
end;

procedure TBeerForm.PrintBtnClick(Sender: TObject);
begin
   graphe.imprime;
end;

procedure TBeerForm.BeerMesureGridSelectCell(Sender: TObject;
   ACol, ARow: integer; var CanSelect: boolean);
begin
   CanSelect := Acol = 0;
end;

procedure TBeerForm.BeerMesureGridKeyPress(Sender: TObject; var Key: char);
const
   CharGetFloat: TsyscharSet = ['0'..'9', '+', '-', 'e', 'E', '.', ',', crSupprArr, crTab, crCR];
begin
   if charinset(key,[',', '.']) then
      key := decimalSeparator
   else if not charinset(key,CharGetFloat) then
      key := #0;
end;

procedure TBeerForm.BeerMesureGridSetEditText(Sender: TObject;
   ACol, ARow: integer; const Value: string);
begin
   if (Acol = 0) and (arow >= 2) then
      with graphe do
      begin
         try
            valeurX[arow - 2] := StrToFloat(Value);
            if (valeurX[arow - 2] > mondeX.maxi) then
            begin
               mondeX.maxi := valeurX[arow - 2] * 1.05;
               oscillo.refresh;
            end;
         except
         end;
      end;
end;

procedure TBeerForm.FormKeyPress(Sender: TObject; var Key: char);
begin
   if (key = ' ') and (modeAcq = maIncrement) and
      enregistreBtn.Visible and enregistreBtn.Enabled then
   begin
      enregistreBtnClick(Sender);
      key := #0;
   end;
end;

procedure TBeerForm.SaveBtnClick(Sender: TObject);
begin
   if regressiM.Checked then
      if ConstanteDlg.showModal = mrOk then
      begin
         DejaSauve := True;
         EnvoieDonnees(True);
         constanteDlg.newPageCB.ItemIndex := 1;
      end;
   if clipM.Checked then
   begin
      DejaSauve := True;
      EnvoieDonnees(False);
   end;
   if fileM.Checked then
      SaveItem;
end;

procedure TBeerForm.RegressiMClick(Sender: TObject);
begin
   saveBtn.ImageIndex := (Sender as TmenuItem).imageIndex;
   (Sender as TmenuItem).Checked := True;
   SaveBtnClick(Sender);
end;

end.

