unit S250cfg;

interface

uses Windows,sysutils,forms,classes,dialogs,
     jmmUtil,inifiles,comCtrls,registry,
     oomisc, adPort, awuser, lnsWin32;

const
   NbreMaxSpectro = 16;
   NbreAide = 8;
   NbreAppConnu = 5;
   LambdaLampe : word = 330;
   CharLambda = ansiChar(136);
   DureeMax = 3600*4; // 4 heures de TP
   TimeOut = 36; // 2 secondes en Tick
   TimeOutms = 2000; // en ms

type
  pseudoWord = record case byte of
             0 : (octets : array[0..1] of ansichar);
             1 : (mot : word);
             2 : (entier : smallInt);
             3 : (octet : byte);
  end;

  TSpectro = class(Tobject)
      constructor Create;
      public
        MiniAbs,MaxiAbs : double;
        MiniLambda,MaxiLambda : integer; { en nm }
        LambdaFiltreIR,LambdaFiltreUV : integer;
        IntervalGOTO : integer;
        Baud : LongInt;
        vitesse : word;
        NbreSpectro,NumeroSpectro : integer;
        RetirerZero : boolean;
        ComNumber : word;
        Function WordToAbs(valeur1,valeur2 : word) : double;
        Procedure sauveConfig;
        Procedure chargeConfig;
  end;

  TCfgSpectro = record
       Aide : array[1..NbreAide] of string;
       Nom : string;
       BaudC : LongInt;
       RetirerZeroC : boolean;
       MiniLambdaC,MaxiLambdaC : integer; { en nm }
  end;

var
   Spectros : array[0..NbreMaxSpectro] of TcfgSpectro;
   S250 : TSpectro;
   NomFichierIni : string;

function IsPortAvailable(ComNum : Cardinal) : Boolean;

implementation

constructor TSpectro.Create;
begin
inherited create;
MiniAbs := 0;
MaxiAbs := 3;
MiniLambda := 334;
MaxiLambda := 900;
LambdaFiltreIR := 380;
LambdaFiltreUV := 660;
vitesse := 5;
NumeroSpectro := 0;
NbreSpectro := 1;
IntervalGOTO := 7;
RetirerZero := true;
end;

procedure TSpectro.chargeConfig;
var NomFichier : string;

const SpectroDefaut : TcfgSpectro =(
   Aide : ( 'Vrifier que le S250 est teint et son porte-cuve vide',
            'Allumer le S250 et attendre environ 30 secondes',
            'cas 1 : "tESt" disparait du S250 : il est prt',
            'cas 2 : "PC" apparat sur le S250',
            '---> appuyer alors sur le bouton gauche "->/o"  du S250',
            '',
            '',
            '');
            Nom : 'S250PC';
            BaudC : 4800;
            RetirerZeroC : True;
            MiniLambdaC : 334;
            MaxiLambdaC : 900);

procedure chargeConfigLoc;
var j,k : integer;
    section : string;
    Ini : tMemIniFile;
begin
            try
            Ini := tMemIniFile.create(NomFichier);
       //     MaxiAbs := Ini.ReadFloat('Spectro','MaxiA',3);
            Vitesse := Ini.ReadInteger('Spectro','Vitesse',5);
            if vitesse>8 then vitesse := 5;
            if vitesse<1 then vitesse := 5;           
            NbreSpectro := Ini.ReadInteger('Spectro','NbreSpectro',1);
            NumeroSpectro := Ini.ReadInteger('Spectro','NumeroSpectro',0);
            ComNumber := Ini.ReadInteger('Spectro','Com',1);
            for k := 0 to pred(NbreSpectro) do with Spectros[k] do begin
                section := 'Aide'+intToStr(k);
                for j := 1 to NbreAide do
                    Aide[j] := Ini.ReadString(section,'Ligne'+intToStr(j),SpectroDefaut.Aide[j]);
                Nom := Ini.ReadString(section,'Nom',SpectroDefaut.nom);
                BaudC := Ini.ReadInteger(section,'Baud',SpectroDefaut.BaudC);
                RetirerZeroC := Ini.ReadBool(section,'ZeroManuel',true);
                ComNumber := Ini.ReadInteger(section,'Com',1);
                MiniLambdaC := Ini.ReadInteger(section,'MiniL',SpectroDefaut.MiniLambdaC);
                MaxiLambdaC := Ini.ReadInteger(section,'MaxiL',SpectroDefaut.MiniLambdaC);
       //     LambdaFiltreUV := Ini.ReadInteger(section,'FiltreUV',LambdaFiltreUV);
       //     LambdaFiltreIR := Ini.ReadInteger(section,'FiltreIR',LambdaFiltreIR);

            end;
            Ini.free;
            baud := Spectros[NumeroSpectro].baudC;
            retirerZero := Spectros[NumeroSpectro].retirerZeroC;
            miniLambda := Spectros[NumeroSpectro].miniLambdaC;
            maxiLambda := Spectros[NumeroSpectro].maxiLambdaC;
            except
            end;
end;

procedure Defaut;
var j : integer;
begin
            Vitesse := 5;
            NbreSpectro := 1;
            NumeroSpectro := 1;
            ComNumber := 1;
            with Spectros[0] do begin
                for j := 1 to NbreAide do
                    Aide[j] := SpectroDefaut.Aide[j];
                Nom := SpectroDefaut.nom;
                BaudC := SpectroDefaut.BaudC;
                MiniLambdaC := SpectroDefaut.MiniLambdaC;
                MaxiLambdaC := SpectroDefaut.MaxiLambdaC;
                RetirerZeroC := true;
                ComNumber := 1;
            end;
            baud := Spectros[0].baudC;
            retirerZero := Spectros[0].retirerZeroC;
end;

begin
    Defaut;
    NomFichier := NomFichierIni;
    if FileExists(NomFichier) then begin
       chargeConfigLoc;
       exit;
    end;
    NomFichier := changeFileExt(application.exeName,'.ini');
    if FileExists(NomFichier) then begin
       chargeConfigLoc;
       exit;
    end;
    NomFichier := mesDocsDir+'s250.ini';
    if FileExists(NomFichier) then begin
       chargeConfigLoc;
       exit;
    end;
end;

procedure TSpectro.sauveConfig;
var j,k : integer;
    section : string;
    Ini : tMemIniFile;
begin
    try
    Ini := tMemIniFile.create(nomFichierIni);
//     Ini.WriteFloat('Spectro','MaxiA',MaxiAbs);
//     Ini.WriteInteger('Spectro','FiltreUV',LambdaFiltreUV);
//     Ini.WriteInteger('Spectro','FiltreIR',LambdaFiltreIR);
     Ini.WriteInteger('Spectro','NbreSpectro',NbreSpectro);
     Ini.WriteInteger('Spectro','NumeroSpectro',NumeroSpectro);
     Ini.WriteInteger('Spectro','Com',ComNumber);
     Ini.WriteInteger('Spectro','Vitesse',Vitesse);
     for k := 0 to pred(NbreSpectro) do with Spectros[k] do begin
         section := 'Aide'+intToStr(k);
         for j := 1 to NbreAide do
            Ini.WriteString(section,'Ligne'+intToStr(j),Aide[j]);
         Ini.WriteString(section,'Nom',Nom);
         Ini.WriteInteger(section,'Baud',BaudC);
         Ini.WriteBool(section,'ZeroManuel',RetirerZeroC);
         Ini.WriteInteger(section,'MaxiL',MaxiLambdaC);
         Ini.WriteInteger(section,'MiniL',MiniLambdaC);
     end;
     Ini.UpdateFile;
     Ini.free;
     except
     end;
end;

Function Tspectro.WordToAbs(valeur1,valeur2 : word) : double;
begin
     result := (valeur1*256.0+valeur2*1.0)/10000.0;
     if result>3.2767 then result := result-6.5535;
     if valeur1=255 then result := 0;
end ;

function IsPortAvailable(ComNum : Cardinal) : Boolean;

  function MakeComName(const Dest : PChar; const ComNum : Cardinal) : PChar;
    {-Return a string like 'COMXX'}
  begin
     StrFmt(Dest,'\\.\COM%d',[ComNum]);
     MakeComName := Dest;
  end;

var
  ComName : array[0..16] of Char;
  Res : Integer;
  DeviceLayer : TApdBaseDispatcher;
  Reg : Tregistry;
begin

  Reg := Tregistry.create;
  Reg.rootKey := Hkey_local_machine;
  Reg.openKey('\Hardware\DeviceMap\SerialComm',true);
  result := (Reg.readString('\Device\porte'+intToStr(comNum)))=''; // ports internes Toshiba ?
  Reg.Free;
  if not result then exit;

  DeviceLayer  := TApdWin32Dispatcher.Create(nil);
  try
    if (ComNum = 0)
       then Result := False
       else begin
         Res := DeviceLayer.OpenCom(MakeComName(ComName,ComNum), 64, 64);
         if (Res < 0) and
            (GetLastError <> DWORD(Abs(ecAccessDenied)))
             then Result := False
             else begin
               Result := True;
               DeviceLayer.CloseCom;
             end;
    end;
  finally
    DeviceLayer.Free;
  end;
end;

initialization
    NomFichierIni := appDataDir+'s250.ini';
end.
