unit S250cinet;

interface

uses Windows, Classes, Graphics, Forms, Controls, Menus,
   Dialogs, StdCtrls, Buttons, ExtCtrls, SysUtils, Messages, clipBrd,
   spin,inifiles,ComCtrls, ToolWin,
   ADport, ADexcept, oomisc, math,
   graphker, jmmUtil, S250cfg, s250main;

type
   TEtatAcquisition = (eaReglageLambda, eaReglageZero, eaEnCours, eaTerminee, eaAttente);

   TCinetiqueForm = class(TForm)
      SaveDialog:    TSaveDialog;
      Timer:         TTimer;
      Oscillo:       TPaintBox;
      BoutonsPanel:  TPanel;
      DureeEdit:     TEdit;
      DureeSB:       TSpinButton;
      LabelDeltat:   TLabel;
      PanelDuree:    TPanel;
      ZeroBtn:       TBitBtn;
      LambdaBtn:     TBitBtn;
      Label1:        TLabel;
      Label2:        TLabel;
      LambdaSE:      TSpinEdit;
      StartBtn:      TBitBtn;
      Label3:        TLabel;
      NbreEdit:      TEdit;
      NbreSpin:      TSpinButton;
      EditBidon:     TEdit;
      Label4:        TLabel;
      PanelAbs:      TPanel;
      LectureS:      TShape;
      ToolBar1:      TToolBar;
      SaveBtn:       TToolButton;
      RepereBtn:     TToolButton;
      ResetBtn:      TToolButton;
      StopBtn:       TToolButton;
      ZeroBtnBis:    TToolButton;
      ExitBtn:       TToolButton;
      PrintBtn:      TToolButton;
      SavePopupMenu: TPopupMenu;
      RegressiM:     TMenuItem;
      ClipM:         TMenuItem;
      FileM:         TMenuItem;
      procedure ExitItemClick(Sender: TObject);
      procedure FormCreate(Sender: TObject);
      procedure TimerTimer(Sender: TObject);
      procedure InitAttente;
      procedure StartBtnClick(Sender: TObject);
      procedure OscilloPaint(Sender: TObject);
      procedure StopBtnClick(Sender: TObject);
      procedure ResetBtnClick(Sender: TObject);
      procedure RepereBtnClick(Sender: TObject);
      procedure FilePageItemClick(Sender: TObject);
      procedure RegPageBtnClick(Sender: TObject);
      procedure EnregistreBtnClick(Sender: TObject);
      procedure DureeSBDownClick(Sender: TObject);
      procedure DureeSBUpClick(Sender: TObject);
      procedure FormClose(Sender: TObject; var Action: TCloseAction);
      procedure ZeroBtnClick(Sender: TObject);
      procedure LambdaBtnClick(Sender: TObject);
      procedure ExitBtnClick(Sender: TObject);
      procedure FormDestroy(Sender: TObject);
      procedure LambdaSEChange(Sender: TObject);
      procedure NbreSpinDownClick(Sender: TObject);
      procedure NbreSpinUpClick(Sender: TObject);
      procedure NbreEditChange(Sender: TObject);
      procedure EditBidonKeyPress(Sender: TObject; var Key: char);
      procedure ZeroBtnBisClick(Sender: TObject);
      procedure PrintBtnClick(Sender: TObject);
      procedure RegressiMClick(Sender: TObject);
      procedure SaveBtnClick(Sender: TObject);
   private
      Hlambda:        integer;
      NbreMax:        integer;
      DureeMesure, DeltatMesure: word; { en s }
      EtatAcq:        TetatAcquisition;
      InstantDebut:   TdateTime;
      NomFichierData: string;
      DejaSauve, FormatRW3: boolean;
      ValeurCourante: double;
      fichier:        textFile;
      procedure EcritPageRW3;
      procedure EcritPageTableur;
      procedure EnregistrePoint;
      procedure setBoutons(etat: TEtatAcquisition);
      procedure DureeSBClick;
      procedure TriggerData(CP: TObject; TriggerHandle: word);
      procedure ChangeNbre;
   public
      Graphe: Tgraphe;
   protected
      procedure WMGetMinMaxInfo(var Msg: TWMGetMinMaxInfo); message wm_GetMinMaxInfo;
   end;

var
   CinetiqueForm: TCinetiqueForm;

implementation

uses S250DDE, s250cst;

const
   minPoints = 15;
   deltatMin = 2; { soit 30 secondes }

{$R *.DFM}

procedure TCinetiqueForm.ExitItemClick(Sender: TObject);
begin
   Close;
end;

procedure TCinetiqueForm.EcritPageRW3;
var
   j: indiceVecteur;
   i: integer;
   repere: Trepere;
begin
   with graphe do
   begin
      writeln(fichier, symbReg, 1, ' PAGE COMMENT');
      if constanteDlg.EditComm.Text <> '' then
         writeln(fichier, constanteDlg.EditComm.Text)
      else
         writeln(fichier, 'Suivi de cintique par spectro S250 ' + DateTimeToStr(date + time));
      writeln(fichier, symbReg2, NbrePoints, ' VALEUR VAR');
      for j := 0 to pred(NbrePoints) do
      begin
         Write(fichier, FloatToStrPoint(valeurX[j]));
         Write(fichier, ' ', FloatToStrPoint(valeurY[1, j]));
         writeln(fichier);
      end; { for j }
      if constanteDlg.AvecConstante then
      begin
         writeln(fichier, symbReg2, '1 VALEUR CONST');
         writeln(fichier, constanteDlg.ValeurConstEdit.Text);
      end;
      if ListeRepere.Count > 0 then
      begin
         writeln(fichier, symbReg2, ListeRepere.Count, ' REPERE');
         for i := 0 to pred(ListeRepere.Count) do
         begin
            repere := Trepere(listeRepere[i]);
            writeln(fichier, FloatToStrPoint(repere.valeur),
               crTab, repere.Text);
         end;
      end;
   end;
end; {ecritPageRW3}

procedure TCinetiqueForm.EcritPageTableur;
var
   j: indiceVecteur;
   i: integer;
   repere: Trepere;
begin
   with graphe do
   begin
      for j := 0 to pred(NbrePoints) do
      begin
         Write(fichier, FloatToStrPoint(valeurX[j]));
         Write(fichier, crTab, FloatToStrPoint(valeurY[1, j]));
         writeln(fichier);
      end;
      if ListeRepere.Count > 0 then
      begin
         writeln(fichier);
         writeln(fichier, 'REPERE');
         for i := 0 to pred(ListeRepere.Count) do
         begin
            repere := Trepere(listeRepere[i]);
            Write(fichier, FloatToStrPoint(repere.valeur), crTab, repere.Text);
            writeln(fichier);
         end; { for j }
      end;
      with constanteDlg do
         if AvecConstante then
         begin
            writeln(fichier, symbReg2, '1 VALEUR CONST');
            writeln(fichier, ValeurConstEdit.Text);
         end;
   end;
end; {ecritPageTableur}

procedure TCinetiqueForm.FormCreate(Sender: TObject);
var
   regini: TmemIniFile;
begin
   Graphe  := Tgraphe.Create;
   graphe.NbreCourbe := 1;
   graphe.trace := tPoint;
   Hlambda := 0;
   Graphe.Canvas := Oscillo.Canvas;
   DeltatMesure := deltatMin;
   DejaSauve := False;
   NbreMax := 64;
   InstantDebut := time;
   DureeMesure := DeltatMesure * NbreMax;
   DureeEdit.Text := TimeToStr(EncodeDuree(DureeMesure));
   NbreEdit.Text := IntToStr(NbreMax);
   LabelDeltat.Caption := delta + 't=' + IntToStr(deltatMesure) + ' s';
   with graphe do
   begin
      mondeX.nom  := 't';
      mondeY.nom  := 'A';
      mondeX.signif := 'temps';
      mondeY.nom  := 'Absorbance';
      mondeX.unite := 's';
      mondeY.unite := '';
      MondeX.Mini := 0;
      mondeY.mini := 0;
      MondeX.Maxi := dureeMesure;
      mondeY.maxi := S250.maxiAbs;
   end;
   LambdaSE.MinValue := S250.miniLambda;
   LambdaSE.MaxValue := S250.maxiLambda;
   LambdaSE.Value := 500;
   try
      RegIni := tMemIniFile.Create(NomFichierIni);
      regressiM.Checked := regIni.ReadBool('Save', 'Regressi', True);
      if regressiM.Checked then
         saveBtn.ImageIndex := regressiM.imageIndex;
      clipM.Checked := regIni.ReadBool('Save', 'Clip', False);
      if clipM.Checked then
         saveBtn.ImageIndex := clipM.imageIndex;
      fileM.Checked := regIni.ReadBool('Save', 'File', False);
      if fileM.Checked then
         saveBtn.ImageIndex := fileM.imageIndex;
      regIni.Free;
   except
   end;
   setBoutons(eaReglageLambda);
end;

procedure TCinetiqueForm.TimerTimer(Sender: TObject);
begin
   lectureS.Visible := True;
   Application.ProcessMessages;
   valeurCourante := FormMain.getAbsorbance;
   if not isnan(valeurCourante) then
      EnregistrePoint;
   lectureS.Visible := False;
end;

procedure TCinetiqueForm.InitAttente;
var
   i: integer;
begin
   with graphe do
   begin
      timer.Enabled := False;
      DureeMesure := DeltatMesure * NbreMax;
      DureeEdit.Text := TimeToStr(EncodeDuree(DureeMesure));
      LabelDeltat.Caption := IntToStr(deltatMesure) + ' s';
      Reset;
      MondeX.Maxi := dureeMesure;
      MondeY.maxi := S250.maxiAbs;
      for i := 0 to MaxVecteur do
         valeurX[i] := i * deltatMesure;
      PanelDuree.Caption := '';
      PanelAbs.Caption := '';
      Oscillo.Refresh;
      SetBoutons(eaAttente);
   end;
end; { InitAttente }

procedure TCinetiqueForm.StartBtnClick(Sender: TObject);
begin
   if (EtatAcq = eaTerminee) and not DejaSauve and
      (MessageDlg('Sauvegarde', mtConfirmation, [mbYes, mbNo], 0) = idYes) then
      SaveBtnClick(Sender);
   InstantDebut := time;
   DejaSauve := False;
   graphe.NbrePoints := 0;
   SetBoutons(eaEnCours);
   TimerTimer(nil); { valeur Initiale }
end;

procedure TCinetiqueForm.OscilloPaint(Sender: TObject);
begin
   graphe.limiteFenetre := Oscillo.clientRect;
   graphe.Draw;
end;

procedure TCinetiqueForm.StopBtnClick(Sender: TObject);
begin
   if (Graphe.NbrePoints > minPoints) or (Graphe.NbrePoints > NbreMax div 2) then
      setBoutons(eaTerminee)
   else
      ResetBtnClick(Sender);
end;

procedure TCinetiqueForm.SetBoutons(etat: TetatAcquisition);
var
   mini, maxi: double;
begin
   EtatAcq := etat;
   StartBtn.Visible := Etat = eaAttente;
   ResetBtn.Visible := Etat = eaTerminee;
   StopBtn.Visible := Etat = eaEnCours;
   ExitBtn.Visible := Etat <> eaEnCours;
   RepereBtn.Enabled := Etat = eaEnCours;
   LambdaBtn.Visible := Etat = eaReglageLambda;
   ZeroBtn.Visible := Etat = eaReglageZero;
   ZeroBtnBis.Visible := Etat <> eaReglageZero;
   LambdaSE.Enabled := not (EtatAcq in [eaEnCours, eaTerminee]);

   SaveBtn.Visible  := Etat = eaTerminee;
   PanelDuree.Visible := Etat = eaEnCours;
   PanelAbs.Visible := Etat = eaEnCours;
   NbreSpin.Visible := etat <> eaEnCours;
   NbreEdit.Enabled := etat <> eaEnCours;

   if Etat = eaEnCours then
      timer.Interval := DeltatMesure * 1000
   else
      timer.Interval := TimeOutMs;
   Timer.Enabled := Etat = eaEnCours;
   if Etat = eaTerminee then
   begin
      if graphe.NbrePoints > 2 then
         GetMinMax(graphe.valeurY[1], graphe.NbrePoints, mini, maxi)
      else
         maxi := S250.maxiAbs;
      if maxi < 1 then
         maxi := 1;
      graphe.SetMonde(0, 0, dureeMesure, maxi);
      Oscillo.refresh;
   end;
end;

procedure TCinetiqueForm.ResetBtnClick(Sender: TObject);
begin
   with graphe do
   begin
      NbrePoints := 0;
      ListeRepere.Clear;
      Oscillo.refresh;
      setBoutons(eaAttente);
      PanelDuree.Caption := '';
      PanelAbs.Caption := '';
   end;
end;

procedure TCinetiqueForm.RepereBtnClick(Sender: TObject);
var
   texte: string;
   InstantClick: double;
begin
   instantClick := DureeEcoulee(instantDebut);
   texte := InputBox('Cration d''un repre', 'Signification', '');
   graphe.AjouteRepere(instantClick, texte);
end;

procedure TCinetiqueForm.EnregistrePoint;
begin
   with graphe do
   begin
      valeurX[NbrePoints] := DureeEcoulee(instantDebut);
      panelDuree.Caption := TimeToStr(time - instantDebut);
      panelAbs.Caption := floatToStrF(valeurCourante, ffFixed, 4, 3);
      valeurY[1, NbrePoints] := valeurCourante;
      traceUnPoint(NbrePoints, 1);
      Inc(NbrePoints);
      if DureeEcoulee(instantDebut) > dureeMesure then
      begin
         SetBoutons(eaTerminee);
         if FormMain.AppelRegressi then
         begin
            constanteDlg.newPageCB.ItemIndex := 1;
            FormDDE.EnvoieDonneesCinetique(True);
            FormMain.AppelRegressi := False;
         end;
      end;
   end;
end;

procedure TCinetiqueForm.FilePageItemClick(Sender: TObject);
begin
   AssignFile(fichier, NomFichierData);
   Append(fichier);
   if formatRW3 then
      ecritPageRW3
   else
      ecritPageTableur;
   CloseFile(fichier);
end;

procedure TCinetiqueForm.RegPageBtnClick(Sender: TObject);
begin
   if ConstanteDlg.showModal = mrOk then
   begin
      FormDDE.EnvoieDonneesCinetique(True);
      constanteDlg.newPageCB.ItemIndex := 1;
   end;
end;

procedure TCinetiqueForm.EnregistreBtnClick(Sender: TObject);
begin
   EnregistrePoint;
   SaveBtn.Visible := graphe.NbrePoints > 3;
end;

procedure TCinetiqueForm.DureeSBClick;
begin
   if NbreMax > maxVecteur then
      NbreMax := maxVecteur;
   DureeMesure := DeltatMesure * NbreMax;
   DureeEdit.Text := TimeToStr(EncodeDuree(DureeMesure));
   LabelDeltat.Caption := IntToStr(deltatMesure) + ' s';
   graphe.MondeX.Maxi := dureeMesure;
   NbreEdit.Text  := IntToStr(NbreMax);
   if EtatAcq = eaEnCours then
      timer.Interval := DeltatMesure * 1000;
   Oscillo.refresh;
end;

procedure TCinetiqueForm.DureeSBUpClick(Sender: TObject);
var
   k: indiceVecteur;
begin
   if etatAcq = eaEnCours then
      if NbreMax < (2 * MaxVecteur div 3) then
         NbreMax := NbreMax * 3 div 2
      else
      begin
         Inc(DeltatMesure);
         with graphe do
            if NbrePoints > (MaxVecteur div 2) then
            begin
               { supprimer un point sur 2 }
               NbrePoints := NbrePoints div 2;
               for k := 1 to pred(NbrePoints) do
               begin
                  valeurX[k] := valeurX[2 * k];
                  valeurY[1, k] := valeurY[1, 2 * k];
               end;
            end;
      end
   else if deltatMesure < 60 then
   begin
      Inc(deltatMesure);
      if DeltatMesure * NbreMax > DureeMax then
         NbreMax := DureeMax div DeltatMesure;
   end;
   DureeSBclick;
end;

procedure TCinetiqueForm.DureeSBDownClick(Sender: TObject);
begin
   if DeltatMesure > deltatMin then
      Dec(deltatMesure)
   else
   begin
      NbreMax := 2 * NbreMax div 3;
      if NbreMax < minPoints then
         NbreMax := minPoints;
   end;
   DureeSBclick;
end;

procedure TCinetiqueForm.FormClose(Sender: TObject; var Action: TCloseAction);
var
   regini: TmemIniFile;
begin
   if EtatAcq = eaEncours then
      stopBtnClick(Sender);
   if (EtatAcq = eaTerminee) and not DejaSauve and
      (MessageDlg('Sauvegarde', mtConfirmation, [mbYes, mbNo], 0) = idYes) then
      SaveBtnClick(Sender);
   try
      RegIni := tMemIniFile.Create(NomFichierIni);
      regIni.WriteBool('Save', 'Regressi', regressiM.Checked);
      regIni.WriteBool('Save', 'Clip', clipM.Checked);
      regIni.WriteBool('Save', 'File', fileM.Checked);
      regIni.UpdateFile;
      RegIni.Free;
   except
   end;
   Timer.Enabled := False;
   FormMain.setMode(mNone);
end;

procedure TCinetiqueForm.ZeroBtnClick(Sender: TObject);
begin
   FormMain.setZero;
   initAttente;
end;

procedure TCinetiqueForm.LambdaBtnClick(Sender: TObject);
begin
   with FormMain do
   begin
      ZeroBtn.Visible := False;
      LambdaBtn.Visible := False;
      StartBtn.Visible := False;
      voieSerie.OnTriggerData := TriggerData;
      HLambda := voieSerie.AddDataTrigger(crESC, False);
      Screen.cursor := crHourGlass;
      setLambda(lambdaSE.Value);
   end;
end;

procedure TCinetiqueForm.WMGetMinMaxInfo(var Msg: TWMGetMinMaxInfo);
begin
   with Msg.MinMaxInfo^ do
   begin
      ptMinTrackSize := point(550, 120);
      ptMaxTrackSize := point(screen.Width - 20, screen.Height - 20);
   end;
end;

procedure TCinetiqueForm.ExitBtnClick(Sender: TObject);
begin
   Close;
end;

procedure TCinetiqueForm.FormDestroy(Sender: TObject);
begin
   Graphe.Free;
end;

procedure TCinetiqueForm.TriggerData(CP: TObject; TriggerHandle: word);
begin
   if TriggerHandle = Hlambda then
   begin
      FormMain.voieSerie.RemoveTrigger(Hlambda);
      Screen.cursor := crDefault;
      setBoutons(eaReglageZero);
      Hlambda := 0;
   end;
end;

procedure TCinetiqueForm.LambdaSEChange(Sender: TObject);
begin
   setBoutons(eaReglageLambda);
end;

procedure TCinetiqueForm.ChangeNbre;
begin
   if NbreMax > MaxVecteur then
      NbreMax := MaxVecteur;
   if NbreMax < minPoints then
      NbreMax := minPoints;
   if NbreMax >= 300 then
      NbreMax := 60 * (NbreMax div 60);
   if NbreMax >= 90 then
      NbreMax := 30 * (NbreMax div 30);
   if NbreMax >= 30 then
      NbreMax := 10 * (NbreMax div 10);
   NbreEdit.Text := IntToStr(NbreMax);
   DeltatMesure := DureeMesure div NbreMax;
   if deltatMesure < deltatMin then
   begin
      DeltatMesure := deltatMin;
      DureeMesure  := DeltatMesure * NbreMax;
   end;
   DureeEdit.Text := TimeToStr(EncodeDuree(DureeMesure));
   LabelDeltat.Caption := IntToStr(deltatMesure) + ' s';
   graphe.MondeX.Maxi := dureeMesure;
   if EtatAcq = eaEnCours then
      timer.Interval := DeltatMesure * 1000;
   Oscillo.refresh;
end;

procedure TCinetiqueForm.NbreSpinDownClick(Sender: TObject);
begin
   if NbreMax >= 360 then
      Dec(NbreMax, 60)
   else if NbreMax >= 120 then
      Dec(NbreMax, 30)
   else if NbreMax >= 40 then
      Dec(NbreMax, 10)
   else
      Dec(NbreMax);
   ChangeNbre;
end;

procedure TCinetiqueForm.NbreSpinUpClick(Sender: TObject);
begin
   if NbreMax >= 300 then
      Inc(NbreMax, 60)
   else if NbreMax >= 90 then
      Inc(NbreMax, 30)
   else if NbreMax >= 30 then
      Inc(NbreMax, 10)
   else
      Inc(NbreMax);
   ChangeNbre;
end;

procedure TCinetiqueForm.NbreEditChange(Sender: TObject);
begin
   NbreMax := StrToInt(NbreEdit.Text);
   ChangeNbre;
end;

procedure TCinetiqueForm.EditBidonKeyPress(Sender: TObject; var Key: char);
begin
   if key = ' ' then
   begin
      if StartBtn.Visible then
         startBtnClick(Sender);
      if ZeroBtn.Visible then
         zeroBtnClick(Sender);
      if LambdaBtn.Visible then
         lambdaBtnClick(Sender);
   end;
   key := #0;
end;

procedure TCinetiqueForm.ZeroBtnBisClick(Sender: TObject);
begin
   FormMain.setZero;
end;

procedure TCinetiqueForm.PrintBtnClick(Sender: TObject);
begin
   Graphe.imprime;
end;

procedure TCinetiqueForm.RegressiMClick(Sender: TObject);
begin
   saveBtn.ImageIndex := (Sender as TmenuItem).imageIndex;
   (Sender as TmenuItem).Checked := True;
   SaveBtnClick(Sender);
end;

procedure TCinetiqueForm.SaveBtnClick(Sender: TObject);

   procedure SaveItem;

      procedure ecritEnTeteTableur;
      begin
         with graphe do
         begin
            writeln(fichier, 'Cintique avec S.250PC');
            writeln(fichier, 't' + crTab + 'A');
            writeln(fichier, 's' + crTab + '');
         end;
      end; { ecritEnTeteTableur }

      procedure ecritEnTeteRW3;
      begin
         with graphe, constanteDlg do
         begin
            writeln(fichier, 'EVARISTE REGRESSI WINDOWS 1.0');
            writeln(fichier, symbReg, '2 NOM VAR');
            writeln(fichier, 't');
            writeln(fichier, 'A');
            writeln(fichier, symbReg, '2 UNITE VAR');
            writeln(fichier, 's');
            writeln(fichier, '');
            writeln(fichier, symbReg, '2 SIGNIF VAR');
            writeln(fichier, 'dure');
            writeln(fichier, 'Absorbance');
            if AvecConstante then
            begin
               writeln(fichier, symbReg, '1 NOM CONST');
               writeln(fichier, NomConstEdit.Text);
               writeln(fichier, symbReg, '1 UNITE CONST');
               writeln(fichier, UniteConstEdit.Text);
               writeln(fichier, symbReg, '1 SIGNIF CONST');
               writeln(fichier, SignifConstEdit.Text);
            end;
            writeln(fichier, symbReg, '1 ACQUISITION');
            writeln(fichier, Application.ExeName);
         end;
      end; { ecritEnTeteRW3 }

   begin
      SaveDialog.filter := 'Regressi (*.rw3)|*.rw3|Tableur ASCII (*.txt)|*.txt';
      SaveDialog.defaultExt := 'RW3';
      if SaveDialog.Execute then
      begin
         FormatRW3 := AnsiUpperCase(ExtractFileExt(saveDialog.FileName)) = '.RW3';
         NomFichierData := saveDialog.FileName;
         try
            AssignFile(fichier, saveDialog.FileName);
            Rewrite(fichier);
            DejaSauve := True;
            if formatRW3 then
            begin
               ecritEnTeteRW3;
               ecritPageRW3;
            end
            else
            begin
               ecritEnTeteTableur;
               ecritPageTableur;
            end;
            CloseFile(fichier);
         except
            ShowMessage('Erreur d''criture du fichier');
         end;
      end;
   end;

begin
   if regressiM.Checked then
      if ConstanteDlg.showModal = mrOk then
      begin
         DejaSauve := True;
         FormDDE.EnvoieDonneesCinetique(True);
         constanteDlg.newPageCB.ItemIndex := 1;
      end;
   if clipM.Checked then
   begin
      DejaSauve := True;
      FormDDE.EnvoieDonneesCinetique(False);
   end;
   if fileM.Checked then
      SaveItem;
end;

end.

