unit S250com;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Spin, sysUtils, dialogs,
  S250cfg, ComCtrls;

type
  TComCfgDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    VitesseComRG: TRadioGroup;
    GroupBox1: TGroupBox;
    BitBtn1: TBitBtn;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit3: TEdit;
    EditNomListe: TEdit;
    NumeroSB: TSpinButton;
    AddBtn: TSpeedButton;
    DeleteBtn: TSpeedButton;
    ResetBtn: TBitBtn;
    ZeroCB: TCheckBox;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    VitesseSE: TSpinEdit;
    procedure FormActivate(Sender: TObject);
    procedure ResetBtnClick(Sender: TObject);
    procedure NumeroSBDownClick(Sender: TObject);
    procedure NumeroSBUpClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure AddBtnClick(Sender: TObject);
    procedure DeleteBtnClick(Sender: TObject);
    procedure ZeroCBClick(Sender: TObject);
  private
    procedure RecupereCfg;
    procedure SauveCfg;
  public
  end;

var
  ComCfgDlg: TComCfgDlg;

implementation

{$R *.DFM}

procedure TComCfgDlg.FormActivate(Sender: TObject);
begin with S250 do begin
   RecupereCfg;
   AddBtn.visible := NbreSpectro<NbreMaxSpectro;
   DeleteBtn.visible := NbreSpectro>1;
   vitesseSE.Value := vitesse;
end end;

procedure TComCfgDlg.ResetBtnClick(Sender: TObject);
const
     NbreAideDef = 5;
     lignes : array[0..NbreAppConnu,1..NbreAideDef] of string =
        (('Vrifier que S250 est teint et son porte-cuve vide',
          'Allumer le S250, "tESt" apparat',
          'Attendre disparition de "tESt" sur le S250',
          '"PC" apparat sur le S250',
          'Appuyer sur le bouton gauche "->/o"  du S250'),
         ('Vrifier que S250 est teint et son porte-cuve vide',
          '',
          'Allumer le S250 et attendre environ 30 secondes',
          'Attendre disparition de "tESt" sur le S250',
          'Le S250 est alors prt'),
         ('Vrifier que S250 est teint et son porte-cuve vide',
          'Allumer le S250, "tESt" apparat',
          'Attendre disparition de "tESt" sur le S250',
          'Le S250 est alors prt',''),
         ('Vrifier que Prim C est teint et son porte-cuve vide',
          '',
          'Allumer le Prim C et attendre environ 30 secondes',
          '',''),
         ('Vrifier que Prim Advanced est teint et son porte-cuve vide',
          'Allumer le Prim Advanced et attendre l''apparition de "PC"',
          'Le Prim Advance est prt quand "PC" disparat',
          '',''),
         ('Vrifier que Prim Light est teint et son porte-cuve vide',
          'Allumer le Prim Light et attendre l''apparition de "PC"',
          'Le Prim Advance est prt quand "PC" disparat',
          '',''));
     noms : array[0..NbreAppConnu] of string = (
          'S.250 "ancien"',
          'S.250 I/PC',
          'S.250 "rcent"',
          'Prim C',
          'Prim Advanced',
          'Prim Light');

var code,j : integer;
begin
     if MessageDlg('Suppression des modifications ?',mtWarning,mbYesNoCancel,0)<>mrYes then exit;
     for code := 0 to NbreAppConnu do  with Spectros[code] do begin
         for j := 1 to NbreAideDef do
             aide[j] := lignes[code,j];
         for j := succ(NbreAideDef) to NbreAide do aide[j] := '';
         Nom := noms[code];
         if code<3 then BaudC := 4800 else BaudC := 9600;
     end;
     if S250.NbreSpectro<NbreAppConnu then S250.NbreSpectro := NbreAppConnu;
     S250.NumeroSpectro := 0;
     RecupereCfg;
end;

procedure TComCfgDlg.SauveCfg;
begin with Spectros[S250.NumeroSpectro] do begin
       if VitesseComRG.itemIndex=0
          then baudC := 4800
          else baudC := 9600;
       aide[1] := edit1.text;
       aide[2] := edit2.text;
       aide[3] := edit3.text;
       aide[4] := edit4.text;
       aide[5] := edit5.text;
       aide[6] := edit6.text;
       aide[7] := edit7.text;
       aide[8] := edit8.text;       
       nom := editNomListe.text;
       RetirerZeroC := S250.RetirerZero;
end end;

procedure TComCfgDlg.RecupereCfg;
begin with Spectros[S250.NumeroSpectro] do begin
     if baudC=4800
          then VitesseComRG.itemIndex := 0
          else VitesseComRG.itemIndex := 1;
     edit1.text := aide[1];
     edit2.text := aide[2];
     edit3.text := aide[3];
     edit4.text := aide[4];
     edit5.text := aide[5];
     edit6.text := aide[6];
     edit7.text := aide[7];
     edit8.text := aide[8];
     editNomListe.text := nom;
     S250.RetirerZero := retirerZeroC;
     zeroCB.checked := not retirerZeroC;
end end;

procedure TComCfgDlg.NumeroSBDownClick(Sender: TObject);
begin
     if S250.NumeroSpectro>0 then begin
        SauveCfg;
        dec(S250.NumeroSpectro);
        RecupereCfg;
     end;
end;

procedure TComCfgDlg.NumeroSBUpClick(Sender: TObject);
begin
     if S250.NumeroSpectro<(S250.NbreSpectro-1) then begin
        SauveCfg;
        inc(S250.NumeroSpectro);
        RecupereCfg;
     end;
end;

procedure TComCfgDlg.OKBtnClick(Sender: TObject);
begin
    SauveCfg;
    S250.vitesse := vitesseSE.Value;
    S250.sauveConfig;
end;

procedure TComCfgDlg.DeleteBtnClick(Sender: TObject);
var k : integer;
begin with S250 do
if MessageDlg('Suppression de '+Spectros[NumeroSpectro].nom,
     mtConfirmation,[mbYes,mbNo],0)=mrYes
           then begin
     dec(NbreSpectro);
     for k := NumeroSpectro to pred(NbreSpectro) do
         Spectros[k] :=  Spectros[k+1];
     if NumeroSpectro>=NbreSpectro then
        NumeroSpectro := pred(NbreSpectro);
     DeleteBtn.visible := NbreSpectro>1;
     RecupereCfg;
end end;

procedure TComCfgDlg.AddBtnClick(Sender: TObject);
begin with S250 do begin
     Spectros[NbreSpectro] := Spectros[NumeroSpectro];
     Spectros[NbreSpectro].nom := '?'+Spectros[NbreSpectro].nom;
     NumeroSpectro := NbreSpectro;
     Inc(NbreSpectro);
     AddBtn.visible := NbreSpectro<NbreMaxSpectro;
end end;

procedure TComCfgDlg.ZeroCBClick(Sender: TObject);
begin
     S250.retirerZero := not ZeroCB.checked
end;

end.
