unit S250dde;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DdeMan, ExtCtrls, registry, clipbrd,
  jmmUtil, graphker, shellApi,
  S250Auto, s250main, S250Manu, S250cfg, s250cst, S250cinet;

type
  Tenvoi = (eAdd,eLoad,ePlus,eFocus);
  TFormDDE = class(TForm)
    ClientDDE: TDdeClientConv;
    ClientItem: TDdeClientItem;
    ServeurDDE: TDdeServerConv;
    procedure FormCreate(Sender: TObject);
    procedure ExecuteMacro(Sender: TObject; Msg: TStrings);
  private
    function GetFnName(const BufStr: string): string;
    function GetArgs(const BufStr: string): string;
  public
    procedure AjouteConst(var donnees : TstringList);
    procedure Execute(Ordre : Tenvoi);
    procedure EnvoieDonneesSpectre(Agraphe : Tgraphe;DDE : boolean);
    procedure EnvoieDonneesCinetique(DDE : boolean);
  end;

var
  FormDDE: TFormDDE;

implementation

uses S250beer;

{$R *.DFM}

procedure TFormDDE.AjouteConst(var donnees : TstringList);
begin with constanteDlg do
     if avecConstante then begin
        try
            Donnees.Add('');
            Donnees.Add(NomConstEdit.text);
            Donnees.Add(UniteConstEdit.text);
            Donnees.Add(ValeurConstEdit.text);
        except
        end;
     end;
end;

procedure TFormDDE.Execute(Ordre : Tenvoi);

Procedure lanceRegressi;
var hSemaphore : integer;
begin
   hSemaphore := CreateSemaphore(nil,0,1,'Regressi');
   if (hSemaphore<>0) and
      (GetLastError = Error_Already_Exists) then exit;
   if ShellExecute(0, 'open', Pchar(ClientDde.ServiceApplication), nil, nil, SW_SHOWDEFAULT) >= 32 then sleep(2000);
end;

procedure Lance;
begin
    case ordre of
         eAdd : if not ClientDDE.ExecuteMacro('CLIP|ADD', false) then
            ShowMessage('Transfert non excut');
         eLoad : if not ClientDDE.ExecuteMacro('CLIP|LOAD', false) then
            ShowMessage('Transfert non excut');
         ePlus : if not ClientDDE.ExecuteMacro('CLIP|PLUS', false) then
            ShowMessage('Transfert non excut');
         eFocus : if not ClientDDE.ExecuteMacro('FOCUS', false) then
            ShowMessage('Transfert non excut');
    end;
    ClientDDE.CloseLink;
end;

begin
     LanceRegressi;
     ClientDDE.SetLink('REGRESSI','ServeurDDE');
     ClientItem.DDEItem := 'ServeurItem';
     if ClientDDE.OpenLink
       then lance
       else begin
               // OpenLik false efface 
           ClientDDE.SetLink('Regressi','ServeurDDE');
           ClientItem.DDEItem := 'ServeurItem';
           sleep(1000);
           if ClientDDE.OpenLink
              then lance
              else ShowMessage('Impossible de lancer Regressi');
       end;
end;

procedure TFormDDE.EnvoieDonneesSpectre(Agraphe : Tgraphe;DDE : boolean);
var i : indiceVecteur;
    c : integer;
    LigneCourante : string;
    donnees : TstringList;
begin with Agraphe do begin
     Donnees := TstringList.Create;
     Donnees.Add(Application.ExeName);
     Donnees.Add('Spectre  '+DateTimeToStr(date+time));
     Donnees.Add(constanteDlg.editComm.text);
     LigneCourante := CharLambda+crTab+'A';
     if NbreCourbe>1 then begin
        LigneCourante := LigneCourante+'1';
        for c := 2 to NbreCourbe do
            LigneCourante := LigneCourante+crTab+'A'+IntToStr(c);
     end;
     Donnees.Add(LigneCourante);
     LigneCourante := 'nm';
     for c := 1 to NbreCourbe do
         LigneCourante := LigneCourante+crTab+'';
     Donnees.Add(LigneCourante);
     LigneCourante := 'Longueur d''onde';
     for c := 1 to NbreCourbe do
         LigneCourante := LigneCourante+crTab+Titre[c];
     Donnees.Add(LigneCourante);
     for i := 0 to maxVecteur do if valeurX[i]>0 then begin
         LigneCourante := IntToStr(round(valeurX[i]));
         for c := 1 to NbreCourbe do
             LigneCourante := LigneCourante+crTab+
                FloatToStrPoint(valeurY[c,i]);
         Donnees.Add(LigneCourante);
     end;
     AjouteConst(donnees);
     ClipBoard.asText := donnees.text;
     if DDE then if ConstanteDlg.NewPageCB.itemIndex=1
        then Execute(eADD)
        else Execute(eLOAD);
     constanteDlg.newPageCB.itemIndex := 1;
     donnees.free;
end end;

procedure TFormDDE.EnvoieDonneesCinetique(DDE : boolean);
var i : indiceVecteur;
    repere : Trepere;
    donnees : TstringList;
begin with CinetiqueForm,graphe do begin
     Donnees := TstringList.create;
     Donnees.Add(Application.ExeName);
     Donnees.Add('Cintique  '+DateTimeToStr(date+time));
     Donnees.Add(ConstanteDlg.EditComm.text);
     Donnees.Add(MondeX.nom+crTab+MondeY.nom);
     Donnees.Add(MondeX.unite+crTab+MondeY.unite);
     for i := 0 to pred(NbrePoints) do begin
         Donnees.Add(FloatToStrPoint(valeurX[i])+crTab+
           FloatToStrPoint(valeurY[1,i]));
     end;
     AjouteConst(donnees);
     if ListeRepere.count>0 then begin
         Donnees.Add(symbReg2+IntToStr(ListeRepere.count)+' REPERE');
         for i := 0 to pred(ListeRepere.count) do begin
             repere := Trepere(listeRepere[i]);
             Donnees.Add(FloatToStrPoint(repere.valeur)+crTab+repere.text);
         end;
     end;
     ClipBoard.AsText := donnees.text;
     if DDE then if constanteDlg.newPageCB.itemIndex=1
        then Execute(eADD)
        else Execute(eLOAD);
     donnees.free;
     constanteDlg.newPageCB.itemIndex := 1;
end end;

procedure TFormDDE.ExecuteMacro(Sender: TObject; Msg: TStrings);
var Fonction,NomFichier : string;
begin
     if (Msg.Count = 1) then begin
       try
       NomFichier := GetArgs(Msg[0]);
       Fonction := GetFnName(Msg[0]);
       if CompareText('CONFIG|LOAD',Fonction) = 0 then begin
           exit
       end;
       if CompareText('CONFIG|SAVE',Fonction) = 0 then begin
           exit
       end;
       if CompareText('FOCUS',Fonction) = 0 then begin
           case FormMain.AcquisitionEnCours of
                mSpectreAuto : SpectreForm.setFocus;
                mSpectreMinMax : SpectreManuel.setFocus;
                mCinetique : CinetiqueForm.setFocus;
                mNone : FormMain.setFocus;
           end;
           exit;
       end;
       if CompareText('GETDATA',Fonction) = 0 then begin
           FormMain.AppelRegressi := true;
           case FormMain.AcquisitionEnCours of
                mSpectreAuto : SpectreForm.setFocus;
                mSpectreMinMax : SpectreManuel.setFocus;
                mCinetique : CinetiqueForm.setFocus;
                mNone : FormMain.setFocus;
           end;
           exit;
       end;
       MessageDlg('Fonction inconnue : ' + Msg[0], mtError, [mbOK], 0);
       except
            MessageDlg('Syntaxe Macro DDE : Fonction(Paramtre)', mtError, [mbOK], 0);
       end;
     end
     else MessageDlg('Un message  la fois SVP', mtError, [mbOk], 0);
end;

procedure TFormDDE.FormCreate(Sender: TObject);
var Ini : TRegIniFile;
begin
    Ini := TRegIniFile.create('Software\Regressi');
    ClientDDE.ServiceApplication := Ini.ReadString('Regressi','Path','c:\regwin\regressi.exe');
    Ini.Free;
    ClientItem.DDEItem := 'ServeurItem';
end;

function TFormDDE.GetArgs(const BufStr: string): string;
var ArgStart, ArgEnd: byte;
begin
  { recherche parenthses ouvrante et fermante : fonction(argument) }
  ArgStart := Pos('(', BufStr);
  ArgEnd := Pos(')', BufStr);
  if (ArgStart >= ArgEnd)
     then result := ''
     else result := Copy(BufStr, Succ(ArgStart), ArgEnd - Succ(ArgStart));
end;

function TFormDDE.GetFnName(const BufStr: string): string;
var OpenBracketPos: byte;
begin
  OpenBracketPos := Pos('(', BufStr);
  if (OpenBracketPos <= 0)
     then result := BufStr
     else result := Copy(BufStr, 1, Pred(OpenBracketPos));
end;

end.
