unit S250manu;

interface

uses Windows, Classes, Graphics, Forms, Controls, Menus,
   Dialogs, StdCtrls, Buttons, ExtCtrls, SysUtils, Messages,
   clipBrd, spin, inifiles, Grids, ComCtrls, ToolWin,
   ADport, adexcept, oomisc, math,
   S250cfg, graphker, jmmUtil, s250main;

type
   TSpectreManuel = class(TForm)
      SaveDialog:    TSaveDialog;
      PaintBox:      TPaintBox;
      PanelBoutons:  TPanel;
      LambdaGB:      TGroupBox;
      DebutSE:       TSpinEdit;
      FinSE:         TSpinEdit;
      pasSE:         TSpinEdit;
      Pas:           TLabel;
      Maxi:          TLabel;
      Mini:          TLabel;
      PanelDuree:    TPanel;
      Header:        THeaderControl;
      SpectreGB:     TGroupBox;
      SpectreGrid:   TStringGrid;
      Edit1:         TEdit;
      PanelLambda:   TPanel;
      Edit2:         TEdit;
      ToolBar1:      TToolBar;
      SaveBtn:       TToolButton;
      BlancBtn:      TToolButton;
      StopBtn:       TToolButton;
      ReticuleBtn:   TToolButton;
      ExitBtn:       TToolButton;
      ResetBtn:      TToolButton;
      UndoBtn:       TToolButton;
      SpectreBtn:    TToolButton;
      PrintBtn:      TToolButton;
      SavePopupMenu: TPopupMenu;
      RegressiM:     TMenuItem;
      ClipM:         TMenuItem;
      FileM:         TMenuItem;
      procedure ExitItemClick(Sender: TObject);
      procedure FormCreate(Sender: TObject);
      procedure PaintBoxPaint(Sender: TObject);
      procedure RegSaveBtnClick(Sender: TObject);
      procedure BlancBtnClick(Sender: TObject);
      procedure SpectreBtnClick(Sender: TObject);
      procedure FormActivate(Sender: TObject);
      procedure FormDestroy(Sender: TObject);
      procedure FormClose(Sender: TObject; var Action: TCloseAction);
      procedure BornesChange(Sender: TObject);
      procedure StopBtnClick(Sender: TObject);
      procedure ResetBtnClick(Sender: TObject);
      procedure UndoBtnClick(Sender: TObject);
      procedure ReticuleBtnClick(Sender: TObject);
      procedure PaintBoxMouseMove(Sender: TObject; Shift: TShiftState; X, Y: integer);
      procedure SpectreGridDrawCell(Sender: TObject; ACol, ARow: integer;
         Rect: TRect; State: TGridDrawState);
      procedure SpectreGridSetEditText(Sender: TObject; ACol, ARow: integer;
         const Value: string);
      procedure Edit1KeyPress(Sender: TObject; var Key: char);
      procedure PrintBtnClick(Sender: TObject);
      procedure RegressiMClick(Sender: TObject);
      procedure SaveBtnClick(Sender: TObject);
   private
      HLambda, Habs: word;
      reponse:   shortString;
      Lambda:    word;
      Sauve, BlancFait: boolean;
      Etat:      TetatSpectre;
      graphe:    Tgraphe;
      debutGOTO: TdateTime;
      procedure setBoutonAcq;
      procedure TriggerData(CP: TObject; TriggerHandle: word);
      procedure TriggerAvail(CP: TObject; Count: word);
      procedure SetTrigger;
      procedure SaveItem;
   public
   protected
   end;

var
   SpectreManuel: TSpectreManuel;

implementation

uses S250About, S250DDE, s250cst;

{$R *.DFM}

procedure TSpectreManuel.ExitItemClick(Sender: TObject);
begin
   Close;
end;

procedure TSpectreManuel.SaveItem;
var
   fichier: textFile;

   procedure ecritEnTeteRW3;
   var
      c: indiceCourbe;
   begin with S250, graphe, constanteDlg do begin
         writeln(fichier, 'EVARISTE REGRESSI WINDOWS 1.0');
         writeln(fichier, symbReg, 1 + NbreCourbe, ' NOM VAR');
         writeln(fichier, CharLambda);
         if NbreCourbe = 1 then
            writeln(fichier, 'A')
         else
            for c := 1 to NbreCourbe do
               writeln(fichier, 'A' + IntToStr(c));
         writeln(fichier, symbReg, 1 + NbreCourbe, ' UNITE VAR');
         writeln(fichier, 'nm');
         for c := 1 to NbreCourbe do
            writeln(fichier, '');
         writeln(fichier, symbReg, 1 + NbreCourbe, ' SIGNIF VAR');
         writeln(fichier, 'Longueur d''onde');
         for c := 1 to NbreCourbe do
            writeln(fichier, 'Absorbance');
         if AvecConstante then begin
            writeln(fichier, symbReg, '1 NOM CONST');
            writeln(fichier, NomConstEdit.Text);
            writeln(fichier, symbReg, '1 UNITE CONST');
            writeln(fichier, UniteConstEdit.Text);
            writeln(fichier, symbReg, '1 SIGNIF CONST');
            writeln(fichier, SignifConstEdit.Text);
         end;
         writeln(fichier, symbReg, '1 ACQUISITION');
         writeln(fichier, Application.ExeName);
   end end; { ecritEnTeteRW3 }

   procedure EcritPageRW3;
   var
      j: indiceVecteur;
      c: indiceCourbe;
   begin with graphe do begin
         writeln(fichier, symbReg, 1, ' PAGE COMMENT');
         if constanteDlg.editComm.Text = '' then
            writeln(fichier, DateTimeToStr(date + time))
         else
            writeln(fichier, constanteDlg.editComm.Text);
         writeln(fichier, symbReg2, NbreSpectre, ' VALEUR VAR');
         for j := 0 to maxVecteur do
            if valeurX[j] > 0 then begin
               Write(fichier, IntToStr(round(valeurX[j])));
               for c := 1 to NbreCourbe do
                  Write(fichier, ' ',
                     FloatToStrPoint(valeurY[c, j]));
               writeln(fichier);
            end; { for j }
         if constanteDlg.AvecConstante then begin
            writeln(fichier, symbReg2, '1 VALEUR CONST');
            writeln(fichier, constanteDlg.ValeurConstEdit.Text);
         end;
   end end; {ecritPageRW3}

   procedure EcritTableur;
   var
      j: indiceVecteur;
      c: indiceCourbe;
   begin with graphe do begin
         writeln(fichier, 'Spectre  ' + DateTimeToStr(date + time));
         Write(fichier, 'lambda');
         if NbreCourbe = 1 then
            Write(fichier, crTab, 'A')
         else
            for c := 1 to NbreCourbe do
               Write(fichier, crTab, 'A' + IntToStr(c));
         writeln(fichier);
         Write(fichier, 'nm');
         for c := 1 to NbreCourbe do
            Write(fichier, crTab, ' ');
         writeln(fichier);
         writeln(fichier, constanteDlg.editComm.Text);
         for j := 0 to maxVecteur do
            if valeurX[j] > 0 then begin
               Write(fichier, IntToStr(round(valeurX[j])));
               for c := 1 to NbreCourbe do
                  Write(fichier, crTab, FloatToStrPoint(valeurY[c, j]));
               writeln(fichier);
            end;
         with constanteDlg do
            if avecConstante then
               writeln(fichier, NomConstEdit.Text, ValeurConstEdit.Text, UniteConstEdit.Text);
   end end; {ecritTableur}

var
   formatRW3: boolean;
begin
   SaveDialog.Filter := 'Regressi (*.rw3)|*.rw3|Tableur ASCII (*.txt)|*.txt';
   if SaveDialog.Execute then begin
      FormatRW3 := AnsiUpperCase(ExtractFileExt(saveDialog.FileName)) = '.RW3';
      sauve := True;
      AssignFile(fichier, saveDialog.FileName);
      Rewrite(fichier);
      if formatRW3 then begin
         ecritEnTeteRW3;
         ecritPageRW3;
      end
      else
         ecritTableur;
      CloseFile(fichier);
   end;
end;

procedure TSpectreManuel.FormCreate(Sender: TObject);
var
   regini: TmemIniFile;
begin
   Etat := esAttente;
   Graphe := Tgraphe.Create;
   with graphe, S250 do begin
      nbreCourbe := 0;
      mondeX.unite := 'nm';
      mondeX.nom := LettreLambda;
      mondeX.signif := 'Longueur d''onde';
      mondeY.nom := 'A';
      mondeY.unite := '';
      mondeY.signif := 'Absorbance';
      setMonde(MiniLambda, 0, MaxiLambda, MaxiAbs);
      Trace := tSpectre;
   end;
   DebutSE.MinValue := S250.MiniLambda;
   DebutSE.Enabled := True;
   FinSE.MaxValue := S250.MaxiLambda;
   FinSE.Enabled := True;
   PasSE.Value := 1;
   graphe.NbrePoints := 0;
   HLambda := 0;
   Habs := 0;
   try
      RegIni := tMemIniFile.Create(NomFichierIni);
      regressiM.Checked := regIni.ReadBool('Save', 'Regressi', True);
      if regressiM.Checked then
         saveBtn.ImageIndex := regressiM.imageIndex;
      clipM.Checked := regIni.ReadBool('Save', 'Clip', False);
      if clipM.Checked then
         saveBtn.ImageIndex := clipM.imageIndex;
      fileM.Checked := regIni.ReadBool('Save', 'File', False);
      if fileM.Checked then
         saveBtn.ImageIndex := fileM.imageIndex;
      regIni.Free;
   except
   end;
end;

procedure TSpectreManuel.PaintBoxPaint(Sender: TObject);
var
   maxA: double;
begin with graphe do begin
      Canvas := PaintBox.Canvas;
      limiteFenetre := PaintBox.clientRect;
      if NbreCourbe > 0 then begin
         MaxA := MaxiY(NbreCourbe);
         if maxA < 0.1 then
            maxA := 1;
         if NbreCourbe = 1 then
            MondeY.maxi := maxA
         else if MondeY.maxi < maxA then
            MondeY.maxi := maxA;
      end
      else
         MondeY.maxi := S250.maxiAbs;
      Draw;
      traceFiltres;
      if ReticuleBtn.down and ReticuleBtn.Visible then
         TraceReticule;
      TraceRef;
end end;

procedure TSpectreManuel.RegSaveBtnClick(Sender: TObject);
begin
   if constanteDlg.showModal = mrOk then begin
      sauve := True;
      FormDDE.EnvoieDonneesSpectre(graphe, True);
      constanteDlg.newPageCB.ItemIndex := 1;
   end;
end;

procedure TSpectreManuel.SetBoutonAcq;
const
   hintLambda = 'Inactif|Pour modifier, cliquer sur le bouton RZ';
var
   spectreFait: boolean;
begin
   spectreFait := graphe.NbreCourbe > 0;
   SaveBtn.Enabled := spectreFait;
   SpectreBtn.Enabled := blancFait and (etat = esAttente);
   PanelLambda.Visible := etat <> esAttente;
   BlancBtn.Enabled := etat = esAttente;
   DebutSE.Enabled := etat = esAttente;
   FinSE.Enabled := etat = esAttente;
   stopBtn.Visible := etat <> esAttente;
   PanelDuree.Caption := TimeToStr(EncodeDuree(
      (finSE.Value - debutSE.Value) * S250.IntervalGOTO div pasSE.Value));
   DebutSE.Enabled := not blancFait;
   FinSE.Enabled := DebutSE.Enabled;
   PasSE.Enabled := DebutSE.Enabled;
   resetBtn.Visible := blancFait;
   undoBtn.Visible := spectreFait;
   reticuleBtn.Visible := spectreFait;
   SpectreGB.Visible := spectreFait;
   if SpectreGB.Visible then
      SpectreGrid.rowCount := succ(Graphe.NbreCourbe);
   if DebutSE.Enabled then begin
      LambdaGB.hint := '';
      DebutSE.hint := '';
      pasSE.hint := '';
      FinSE.hint := '';
   end
   else begin
      LambdaGB.hint := hintLambda;
      DebutSE.hint := hintLambda;
      FinSE.hint := hintLambda;
      pasSE.hint := hintLambda;
   end;
   PaintBox.refresh;
end;

procedure TSpectreManuel.BlancBtnClick(Sender: TObject);
var
   i: integer;
begin with graphe do begin
      blancFait := False;
      debutGOTO := time;
      sauve := True;
      etat  := esBlancEnCours;
      MinRef := debutSE.Value;
      MaxRef := debutSE.Value;
      mondeX.mini := debutSE.Value;
      mondeX.maxi := finSE.Value;
      for i := 0 to maxVecteur do begin
         AbsRef[i]  := nan;
         valeurX[i] := 0;
      end;
      setBoutonAcq;
      setTrigger;
end end;

procedure TSpectreManuel.SetTrigger;
begin
   HLambda := FormMain.voieSerie.AddDataTrigger(crESC, False);
   Lambda  := DebutSE.Value;
   reponse := '';
   FormMain.setLambda(lambda);
end;

procedure TSpectreManuel.SpectreBtnClick(Sender: TObject);
var
   j: integer;
begin with graphe do begin
      if sauve and (NbreCourbe = 1) then { page suivante }
      else if NbreCourbe < NbreCourbeMax then
         Inc(graphe.NbreCourbe)
      else begin
         ShowMessage('Nombre maximal de courbes atteint');
         exit;
      end;
      for j := 0 to MaxVecteur do
         valeurY[NbreCourbe, j] := 0;
      debutGOTO := time;
      sauve := False;
      etat  := esSpectreEnCours;
      setBoutonAcq;
      setTrigger;
end end;

procedure TSpectreManuel.FormActivate(Sender: TObject);
begin
   FormMain.voieSerie.OnTriggerAvail := TriggerAvail;
   FormMain.voieSerie.OnTriggerData  := TriggerData;
   setBoutonAcq;
end;

procedure TSpectreManuel.FormDestroy(Sender: TObject);
begin
   Graphe.Free;
end;

procedure TSpectreManuel.FormClose(Sender: TObject; var Action: TCloseAction);
var
   regini: TmemIniFile;
begin
   if (graphe.NbreCourbe > 0) and not (sauve) and
      (MessageDlg('Sauvegarde', mtConfirmation, [mbYes, mbNo], 0) = idYes) then
      SaveBtnClick(Sender);
   if Hlambda > 0 then
      formMain.voieSerie.RemoveTrigger(Hlambda);
   if Habs > 0 then
      formMain.voieSerie.RemoveTrigger(Habs);
   try
      RegIni := tMemIniFile.Create(NomFichierIni);
      regIni.WriteBool('Save', 'Regressi', regressiM.Checked);
      regIni.WriteBool('Save', 'Clip', clipM.Checked);
      regIni.WriteBool('Save', 'File', fileM.Checked);
      regIni.UpdateFile;
      RegIni.Free;
   except
   end;
   FormMain.setMode(mNone);
end;

procedure TSpectreManuel.TriggerData(CP: TObject; TriggerHandle: word);
begin
   if TriggerHandle = Hlambda then begin
      { goto Lambda OK }
      HAbs := FormMain.voieSerie.AddDataTrigger('T', False);
      formMain.voieSerie.RemoveTrigger(HLambda);
      Hlambda := 0;
      reponse := '';
      FormMain.VoieSerie.outPut := crESC + '2';
      { mesure d'absorbance }
   end;
   if TriggerHandle = Habs then begin
      { absorbance OK }
      formMain.voieSerie.RemoveTrigger(HAbs);
      Habs := 0;
      reponse := '';
      FormMain.VoieSerie.outPut := 'E';
      { lecture d'absorbance  }
   end;
end;

procedure TSpectreManuel.TriggerAvail(CP: TObject; Count: word);
var
   AbsLoc: double;
   i: integer;
begin
   for i := 1 to Count do
      if FormMain.voieSerie.charReady then
         reponse := reponse + FormMain.VoieSerie.GetChar;
   if length(reponse) = 4 then
      with graphe do begin { T gain hi lo }
         AbsLoc := S250.WordToAbs(Ord(reponse[3]), Ord(reponse[4]));
         case etat of
            esBlancEnCours: begin
               AbsRef[Lambda] := AbsLoc;
               valeurX[Lambda] := lambda;
               maxRef := lambda;
               traceRef;
            end;
            esSpectreEnCours: with graphe do begin
                  valeurY[NbreCourbe, Lambda] := AbsLoc - AbsRef[Lambda];
                  valeurX[Lambda] := lambda;
                  if valeurY[NbreCourbe, Lambda] > MondeY.maxi then begin
                     MondeY.maxi := valeurY[NbreCourbe, Lambda] * 1.1;
                     PaintBox.Refresh;
                  end
                  else TraceUnPoint(Lambda, NbreCourbe);
               end;
            esAttente: exit;
         end;
         PanelDuree.Caption  := TimeToStr(EncodeDuree(
            (finSE.Value - lambda) * S250.IntervalGOTO div pasSE.Value));
         PanelLambda.Caption := IntToStr(lambda);
         Inc(lambda, pasSE.Value);
         if lambda = S250.LambdaFiltreIR then
            lambda := S250.LambdaFiltreIR + 1;
         if lambda = S250.LambdaFiltreUV then
            lambda := S250.LambdaFiltreUV + 1;
         if lambda > finSE.Value then
            case etat of
               esBlancEnCours: if valeurX[finSE.Value] = 0 then
                     lambda := finSE.Value;
               esSpectreEnCours: if isnan(valeurY[NbreCourbe, finSE.Value])
                  then lambda := finSE.Value;
            end;
         if (lambda <= finSE.Value) then begin
            HLambda := FormMain.voieSerie.AddDataTrigger(crESC, False);
            reponse := '';
            FormMain.setLambda(lambda);
         end
         else begin
            case etat of
               esBlancEnCours: begin
                  BlancFait := True;
                  S250.intervalGOTO :=
                     1 + DureeEcoulee(debutGOTO) * pasSE.Value div
                     (finSE.Value - debutSE.Value);
               end;
               esSpectreEnCours: ;
               esAttente: ;
            end;
            Etat := esAttente;
            setBoutonAcq;
         end;
      end;
end;

procedure TSpectreManuel.BornesChange(Sender: TObject);
begin
   DebutSE.MaxValue := FinSE.Value - 50;
   FinSE.MinValue := DebutSE.Value + 50;
   BlancFait := False;
   SetBoutonAcq;
end;

procedure TSpectreManuel.StopBtnClick(Sender: TObject);
begin
   if (etat = esBlancEnCours) and
      (((lambda - debutSE.Value) div pasSE.Value) > 20) then begin
      blancFait := True;
      finSE.Value := lambda;
   end;
   if (etat = esSpectreEnCours) and (graphe.NbreSpectre < 20) then
      Dec(graphe.NbreCourbe);
   etat := esAttente;
   setBoutonAcq;
end;

procedure TSpectreManuel.ResetBtnClick(Sender: TObject);
var
   j: integer;
begin
   if MessageDlg('Suppression de tous les spectres', mtConfirmation, [mbOK, mbCancel], 0) =
      idOk then begin
      graphe.NbreCourbe := 0;
      sauve := True;
      for j := 0 to MaxVecteur do
         graphe.valeurX[j] := 0;
      setBoutonAcq;
      PaintBox.refresh;
   end;
end;

procedure TSpectreManuel.UndoBtnClick(Sender: TObject);
begin
   if MessageDlg('Suppression du dernier spectre', mtConfirmation, [mbOK, mbCancel], 0) =
      idOk then begin
      Dec(graphe.NbreCourbe);
      UndoBtn.Visible  := graphe.NbreCourbe > 0;
      ResetBtn.Visible := graphe.NbreCourbe > 0;
      PaintBox.refresh;
   end;
end;

procedure TSpectreManuel.ReticuleBtnClick(Sender: TObject);
begin
   Header.sections[1].Text := '';
   Header.sections[0].Text := '';
   graphe.TraceReticule;
end;

procedure TSpectreManuel.PaintBoxMouseMove(Sender: TObject; Shift: TShiftState;
   X, Y: integer);
var
   Xr, Yr: double;
begin
   if ReticuleBtn.down and ReticuleBtn.Visible then
      with Graphe do begin
         TraceReticule; { efface }
         MondeXY(x, y, xr, yr);
         Header.sections[1].Text := ' A=' + FormatCourt(Yr) + ' ';
         Header.sections[0].Text := ' ' + CharLambda + '=' + FormatCourt(Xr) + ' nm';
         XReticule := X;
         YReticule := Y;
         TraceReticule; { marque }
      end;
end;

procedure TSpectreManuel.SpectreGridDrawCell(Sender: TObject;
   ACol, ARow: integer; Rect: TRect; State: TGridDrawState);
begin
   if Arow > 0 then begin
      spectreGrid.canvas.Font.Color := CouleurCourbe[Arow];
      spectreGrid.canvas.TextOut(Rect.Left + 2, Rect.Top + 2, graphe.titre[Arow]);
   end;
end;

procedure TSpectreManuel.SpectreGridSetEditText(Sender: TObject;
   ACol, ARow: integer; const Value: string);
begin
   if Arow > 0 then
      graphe.titre[Arow] := Value;
end;

procedure TSpectreManuel.Edit1KeyPress(Sender: TObject; var Key: char);
begin
   if key = ' ' then
      if SpectreBtn.Enabled then
         spectreBtnClick(Sender)
      else if BlancBtn.Enabled then
         blancBtnClick(Sender);
   key := #0;
end;

procedure TSpectreManuel.PrintBtnClick(Sender: TObject);
begin
   graphe.imprime;
end;

procedure TSpectreManuel.RegressiMClick(Sender: TObject);
begin
   saveBtn.ImageIndex := (Sender as TmenuItem).imageIndex;
   (Sender as TmenuItem).Checked := True;
   SaveBtnClick(Sender);
end;

procedure TSpectreManuel.SaveBtnClick(Sender: TObject);
begin
   if regressiM.Checked then
      if ConstanteDlg.showModal = mrOk then begin
         Sauve := True;
         FormDDE.EnvoieDonneesSpectre(graphe, True);
         constanteDlg.newPageCB.ItemIndex := 1;
      end;
   if clipM.Checked then begin
      Sauve := True;
      FormDDE.EnvoieDonneesSpectre(graphe, False);
   end;
   if fileM.Checked then
      SaveItem;
end;

end.

